// efbat.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <math.h>
#include <time.h>
using namespace std;

#include<vector>					//Necessary to use vectors
typedef vector<int> vint;			//vint declares an integer vector
typedef vector<long> veclong;		//veclong declares a vector of longs.
typedef vector<double> vecd;
typedef class Rec REC;
typedef class Node Node;
typedef class Rec2 REC2;
typedef class Node2 Node2;

const int Nmark = 25; //Maximum number of markers that can be read.
const int buffsize = 650;
const int NumAll = 20;//More than 2 alleles will be reduced to 2 allele case.
const int MaxFamSize = 20;

void logo();
int size(int &rows, int &cols, char filename[80], char markers[][buffsize]);
void network(int xlink,long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int log,char pedfile[80],char logfile[80],int curall,vint allAlls,int cline,int linkage);
void network2(int xlink,long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int log,char pedfile[80],char logfile[80],int curall,vint allAlls,int cline);
void netB(long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int log,char pedfile[80],char logfile[80],int curall,vint allAlls,int cline);
int options(int &linkage,int &xlink,int &mod,int &marker,int &nmark,char markernames[][buffsize],int &log,char logfile[80],char pedfile[80],int &curall,vint &allAlls,long **peddata, int rows,bool open);
void countAlleles(long **peddata,vint &famalls,vint index,int start);
void pedigrees(long** peddata,int npedrows,int &nped,veclong &pids,veclong &mids,veclong &fids);
void nuclear(long** peddata,int npedrows,vint &index,vint &folks,vint &kids,long ped,long dad,long mom,vint &aff,int startpos,vint &sons,vint &dots,int &pa,int &ma,vint &sex);
void nuclear(long** data,int rows,int cols,vint &index,vint &folks,vint &kids,long ped,int dad,int mom,vint &aff,int st);
void alleles(int obsgenos[][2],vint index,vint famalls,long **peddata,int startpos,int curall);
void alleles(int **alls,vint index,vint uall,long **data,int st);
int minmaxX(int obsgenos[][2],int minA[2],int maxA[2],int pa,int ma,vint sons,vint dots,int genson[],int gendot[][2],int &homdot,int minm[3],int maxm[3]);
void minmaxm(vint min,vint max,vint &minm,vint &maxm,int obsgenos[][2],vint kids,vint folks,vint aff,int nall,vint homKid,int genotypes[][4],int ngens);
void minmaxA(int obsgenos[][2],vint &min,vint &max,vint folks,vint kids,int genotypes[][4],vint &homKid);
int checkgenos(int obsgenos[][2],vint sons,vint dots,int pa,int ma);
void mapa(int ma,int pa,int genma[],int &genpa,int obsgenos[][2]);
void TypeX(int obsgenos[][2],int genson[],int gendot[][2],int ma,int pa,vint sons,vint dots,int &homdot);//Find all possible genotypes
void Clear(vint &v1,vint &v2,vint &v3,vint &v4,vint &v5);
double statistic(int obsgenos[][2],vint aff, vint kids, int mod, vint sex,int xlink);
void buildX(int obsgenos[][2],vint &stage,vint &cell,int minA[],int maxA[],int minm[],int maxm[],int homdot,int ma,int pa,vint sons,vint dots);
void buildG(vint minm,vint maxm,int K,vint &stage,vint &A,vint &B,vint min,vint max,vint homKid,int genotypes[][4],vint &AA,vint &BB,int ngens,vint folks);
Node *NDvector(long nl, long nh);
void free_NDvector(Node *v, long nl,long nh);
REC * crerec(double r,double pr);
void freerec(Rec *rec);
void backwardX(int nstage,int nnodes,Node *nodes,int minA[],int maxA[],vint stage,vint cell,vint stpos,vint endpost,int genma[2],
			  int ma,int pa,int homdot,vint sons,vint dots,vint aff,int mod);
void backwardG(int J,vint maxm,vint minm,long nnodes,Node *nodes,vecd fact,vint stage,vint folks,int** allele,vint stpos,vint endpos,vint aff,
			   vint min,vint max,int mod,vint homKid,vint AA,vint BB,int ngens);
double addlog(double num1,double num2);
void forwardX(int nstage,int nnodes,Node *nodes,int minA[],int maxA[],int minm[],int maxm[],vint stage,vint cell,
			 vint stpos,vint endpos,int genma[2],int ma,int pa,int homdot,vint sons,vint dots,vint aff,int mod);
void forwardG(vint maxm,vint minm,long nnodes,int K,Node *nodes,vint stpos,vint endpos,vecd fact,vint folks,vint aff,vint min,vint max,vint stage,
			  int** allele,int mod,vint AA,vint BB,int ngens,vint homKid);
void moment(REC *newrec, Node *tNode, double &ev, double &ev2);
double pvalue(double exval,double var,Node *tNode,REC *tRec,double ObsS);
vecd faclog(int sampsz);
double prbar0(int numsucc, vecd fact,int diff);

void type2(int **alls,vint uall,int genotypes[][4],vint folks,vint kids,vint homKid,vint kidsalls,short &Nobs);
void params(int genotypes[][4],int &ngens,int possgens[][4],vint &gennum,int &homkids,int &homfolk,int **alls,
			int nall,vint kids,vint folks);
double stat2(vint aff,int **alls,vint kids,int mod,double S,int nall,int all,vint &T,int possgen[][4],vint gennum,int ngens,
			vint folks,short Nobs,int homkids,int homfolk);
short moreinf(vint aff,int **alls,vint &kids,int mod,double S,int nall,int all,vint &T,int possgen[][4],vint gennum,int ngens,
			 vint folks,short Nobs,int homkids,int homfolk,double& Save);
void freerec2(Rec2 *rec);
void free_NDvector2(Node2 *v, long nl,long nh);
REC2 * crerec2(double r,double R[],double pr);
Node2 *NDvector2(long nl, long nh);
void dist(Node2 *nodes,vint T,double Sall[][4],int mode,int totA);
void moment2(REC2 *tRec,double prob,double &exval,double &var);
double pvalue2(double exval,double var,double prob,REC2 *tRec,double ObsS);

void networkX2(int xlink,long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int logOn,char pedfile[80],char logfile[80],int curall,vint allAlls,int cline,int linkage);
void switchGens(int obsgenos[][2],vint sons,vint dots,int pa,int ma,vint &T,vint aff,vint sex,vint kids,int mod);
void distX(Node *nodes,vint T);

static int imaxarg1,imaxarg2;
#define IMAX(a,b) (imaxarg1=(a),imaxarg2=(b),(imaxarg1) > (imaxarg2) ?\
(imaxarg1) : (imaxarg2))

static int iminarg1,iminarg2;
#define IMIN(a,b) (iminarg1=(a),iminarg2=(b),(iminarg1) < (iminarg2) ?\
(iminarg1) : (iminarg2))

static double dmaxarg1,dmaxarg2;
#define DMAX(a,b) (dmaxarg1=(a),dmaxarg2=(b),(dmaxarg1) > (dmaxarg2) ?\
(dmaxarg1) : (dmaxarg2))

static double dminarg1,dminarg2;
#define DMIN(a,b) (dminarg1=(a),dminarg2=(b),(dminarg1) < (dminarg2) ?\
(dminarg1) : (dminarg2))


class Rec
{
public:
    double pastr;	//past rank length,
    double pastp;	//past probability,
	int paths;		//Number of paths from that node to end
    REC *nextrec;	//pointer to the next rec.    
};

class Node
{					//Define a class containing the following:
public:
	double spj;		//Shortest path for this family
	double lpj;		//Longest path for current family
	double ev;
	double var;
	double tp;		//total probability of all paths from this nodes to end node,
	REC *rec;		//and a pointer to a record.
	void setNode(double,double,double,double,double,REC*);
};

class Rec2
{
public:	
    double pastr;                   //past rank length,
	double pastR[NumAll];			//past rank length, multivariate case
    double pastp;                   //past probability,	
    REC2 *nextrec;                   //pointer to the next rec.    
};

class Node2
{				//Define a class containing the following:
public:
	double tp;		
	REC2 *rec;	//and a pointer to a record.
	void setNode2(double,REC2*);
};

fstream outlog;

int main(int argc, char* argv[])
{	
	char pedfile[80], markernames[Nmark][buffsize]; //Name of pedigree file, array of marker names.
	char markers[buffsize+1];	//Holds names of all markers in one line.
	long **peddata; //Hold all the data for the pedigree file.
	int npedrows, npedcols;		//Store the number of rows and columns in the pedfile.
	int mod = 1;		//Inheritance model: 1=add (default), 2=dom, 3=rec.
	int log = 0;		//1 if logging to file, 0 otherwise (default).
	int marker = 1;		//The marker to be used.
	int curall = 1;		//This denotes the current allele. As long as it is 1, it will analyze the first allele in allAlls.
	char logfile[80];	//The name of the log file.	
	int startpos = 6 + (marker - 1) * 2;
	int cline = 0;	//1 if using command line.
	int xlink = 0; //1 if x-linked trait, 0 otherwise.
	int linkage = 0; //0 for 'no linkage, no association', 1 for 'linkage, no association'
	bool open = false;
	//fstream outlog1;

	
	clock_t start, finish;
	time_t start1, finish1;	
	double realTime, CPUtime;

	if(argc>1) //Read command line parameters
	{//From the command line, I want to read the ped file name, the inheritance model, the marker #, and the log file name.
		
		if(argc != 7){
			cout <<"\nError: Incorrect number of parameters. \nUsage: xfbatp pedfilename logfile xlinked H_0 model marker"; //CHECK THIS.
			//outlog1 <<"\nError: Incorrect number of parameters.\nUsage: xfbatp pedfilename logfile xlinked H_0 model marker"; //CHECK THIS.
		}
		else
		{
			strncpy(pedfile,argv[1],79);
			strncpy(logfile,argv[2],79);
			xlink = atoi(argv[3]);
			linkage = atoi(argv[4]);
			mod = atoi(argv[5]);
			marker = atoi(argv[6]);		
			cline = 1;
			log = 1;
			outlog.open(logfile,ios::out);
			open = true;

			outlog <<endl << endl << "* * * * * * * *" << endl << endl;
			for(int i = 1; i < argc; i++) outlog <<argv[i] <<" ";
			outlog<< endl;
			
		}
		//cout <<"\n" << pedfile <<" " <<logfile <<" " <<mod <<" " <<marker <<endl;
		
	}
	else
	{
		logo();			//Display the xfbatx logo.
		int go=0;		//1 if file exits, 0 otherwise.
		cout <<"\nEnter pedigree file name: ";
		cin >> pedfile;
	}	

	
	int go=size(npedrows,npedcols,pedfile,markernames);
	if(go==0)
	{
		char quit;
		if(argc < 2){ //Only output when user is using the menus.
			cout <<"\nError opening file: " <<pedfile << ". \n";
			cout <<"Type 'q' to quit ";
			cin >> quit;
		}
		if(log == 1){
			//outlog1.open(logfile,ios::app);
			cout <<"\nError opening file: " <<pedfile << ". \n";
			outlog <<"\nError opening file: " <<pedfile << ". \n";	
			//outlog1.close();
		}
		return 0;
	}
	else 
	{		
		peddata = (long **)malloc(npedrows*sizeof(long*)); //Allocate memory for data.
		for(int irow = 0; irow < npedrows; irow++) peddata[irow]=(long*)malloc(npedcols*sizeof(long));
		fstream infile;
		infile.open(pedfile,ios::in);
		infile.getline(markers,buffsize);				//The first line contains marker names, store this in one place.
		for(int irow = 0; irow < npedrows; irow++)		//Read in the pedigree data.
		{
			for(int icol = 0; icol < npedcols; icol++)
				infile >> peddata[irow][icol];
		}	
		infile.close();		

		vint index, allAlls;
		for(int irow = 0; irow< npedrows; irow++) index.push_back(irow); 
		countAlleles(peddata,allAlls,index,startpos); //Count and record the alleles in the dataset.
				
		if(cline == 1) //Set up and check for errors in options.
		{
			//outlog1.open(logfile,ios::app);
			int nmark = (npedcols-6)/2;	//The number of markers in pedfile.
			int isMarkok = 0;
			for(int imark = 0; imark < nmark; imark++)
				if(marker == imark) isMarkok = 1;
			if(isMarkok == 0){					
				outlog <<"\nMarker " << marker <<" is not a valid choice. \n";
				cout << "\nMarker " << marker <<" is not a valid choice. \n";				
				return 0;
			}
			if(xlink != 1 && xlink !=0){
				outlog << endl<< xlink << " is not a valid option for 'xlinked'.";
				cout << endl<< xlink << " is not a valid option for 'xlinked'.";
				return 0;
			}
			if(linkage != 1 && linkage !=0){
				outlog << endl<< linkage << " is not a valid option for 'null'.";
				cout << endl<< linkage << " is not a valid option for 'null'.";
				return 0;
			}
			if(mod != 1 && mod != 2 && mod !=3){
				outlog << endl<< mod << " is not a valid option for 'model'.";
				cout << endl<< mod << " is not a valid option for 'model'.";
				return 0;
			}
			//outlog1.close();
			if(marker==0){	
				for(int imark = 1; imark <= nmark; imark ++)
				{
					allAlls.clear();
					int startpos = 6 + (imark - 1) * 2;
					countAlleles(peddata,allAlls,index,startpos); //Count and record the alleles in the dataset.						
					for(unsigned int iall = 0; iall < allAlls.size(); iall++)
					{
						if(linkage == 1 && xlink == 0) network2(xlink,peddata,npedrows,npedcols,markernames,imark,mod,1,pedfile,logfile,allAlls[iall],allAlls,cline);
						else if(linkage == 1 && xlink == 1) networkX2(xlink,peddata,npedrows,npedcols,markernames,imark,mod,1,pedfile,logfile,iall,allAlls,cline,linkage);
						else network(xlink,peddata,npedrows,npedcols,markernames,imark,mod,1,pedfile,logfile,iall,allAlls,cline,linkage);
					}												
				}
			}
			else {					
					for(unsigned int iall = 0; iall < allAlls.size(); iall++)
					{
						if(linkage == 1 && xlink == 0) network2(xlink,peddata,npedrows,npedcols,markernames,marker,mod,1,pedfile,logfile,allAlls[iall],allAlls,cline);
						else if(linkage == 1 && xlink == 1) networkX2(xlink,peddata,npedrows,npedcols,markernames,marker,mod,1,pedfile,logfile,iall,allAlls,cline,linkage);
						else network(xlink,peddata,npedrows,npedcols,markernames,marker,mod,1,pedfile,logfile,iall,allAlls,cline,linkage);
					}//Make curall = 1 to analyze the first allele only.					
				}
			return 0;
		}
		else
		{
			int donext = 0; 
			while(donext != 8)
			{
				int nmark = (npedcols-6)/2;	//The number of markers in pedfile.
				donext=options(linkage,xlink,mod,marker,nmark,markernames,log,logfile,pedfile,curall,allAlls,peddata,npedrows,open);	
				if(donext == 8) break;	
				if(log == 1){
					if(open == false) outlog.open(logfile,ios::out);
					open = true;
				}
				if(marker==0){
					start = clock();
					time( &start1 );	
					for(int imark = 1; imark <= nmark; imark ++)
					{
						allAlls.clear();
						int startpos = 6 + (imark - 1) * 2;
						countAlleles(peddata,allAlls,index,startpos); //Count and record the alleles in the dataset.
						if(curall == 0){
							for(unsigned int iall = 0; iall < allAlls.size(); iall++)
							{
								if(linkage == 1 && xlink == 0) network2(xlink,peddata,npedrows,npedcols,markernames,imark,mod,log,pedfile,logfile,allAlls[iall],allAlls,cline);
								else if(linkage == 1 && xlink == 1) networkX2(xlink,peddata,npedrows,npedcols,markernames,imark,mod,log,pedfile,logfile,iall,allAlls,cline,linkage);
								else network(xlink,peddata,npedrows,npedcols,markernames,imark,mod,log,pedfile,logfile,iall,allAlls,cline,linkage);
							}
						}
						else 
						{
							if(linkage == 1 && xlink == 0) network2(xlink,peddata,npedrows,npedcols,markernames,imark,mod,1,pedfile,logfile,allAlls[curall-1],allAlls,cline);
							else if(linkage == 1 && xlink == 1) networkX2(xlink,peddata,npedrows,npedcols,markernames,imark,mod,1,pedfile,logfile,curall-1,allAlls,cline,linkage);
							else network(xlink,peddata,npedrows,npedcols,markernames,imark,mod,1,pedfile,logfile,curall-1,allAlls,cline,linkage);
						}
					}
				}
				else
				{
					if(curall == 0){
						for(unsigned int iall = 0; iall < allAlls.size(); iall++)
						{
							if(linkage == 1 && xlink == 0) network2(xlink,peddata,npedrows,npedcols,markernames,marker,mod,log,pedfile,logfile,allAlls[iall],allAlls,cline);
							else if(linkage == 1 && xlink == 1) networkX2(xlink,peddata,npedrows,npedcols,markernames,marker,mod,log,pedfile,logfile,iall,allAlls,cline,linkage);
							else network(xlink,peddata,npedrows,npedcols,markernames,marker,mod,log,pedfile,logfile,iall,allAlls,cline,linkage);
						}
					}//Make curall = 1 to analyze the first allele only.
					else 
					{
						if(linkage == 1 && xlink == 0) network2(xlink,peddata,npedrows,npedcols,markernames,marker,mod,log,pedfile,logfile,allAlls[curall-1],allAlls,cline);
						else if(linkage == 1 && xlink == 1) networkX2(xlink,peddata,npedrows,npedcols,markernames,marker,mod,log,pedfile,logfile,curall-1,allAlls,cline,linkage);
						else network(xlink,peddata,npedrows,npedcols,markernames,marker,mod,log,pedfile,logfile,curall-1,allAlls,cline,linkage);
					}
				}
				finish = clock();
				time( &finish1 );
			}			
		}
		index.clear();
		
		CPUtime = (double) (finish - start)/ CLOCKS_PER_SEC;
		realTime = difftime(finish1, start1);
		//cout <<"\nCPU time: " <<CPUtime <<", Real Time: " << realTime <<endl;


		//Release dynamically allocated memory
		for (int irow = 0; irow < npedrows; irow++) free(peddata[irow]);
		free(peddata);
		peddata = NULL;
		allAlls.clear();
	}
	if(open == true) outlog.close();
	return 0;
}

void network2(int xlink,long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int logOn,char pedfile[80],char logfile[80],int all,vint allAlls,int cline)
{	
	vint folks,kids,index,aff,affK;  //hold indices of folks and kids for current nuclear family
	vint homKid,allUall,kidsalls;
	vint uall,kindex,gennum,T,stpos;
	veclong peds,moms,dads;	
	unsigned int i,j,x;
	int mom,dad,nped=1,inf=0,nnodes,homkids,homfolk;
	int nall,ngens=0,indA=-1,possgens[4][4];
	int startpos=6+2*(marker-1); //This says which marker I want to test.
	double variance=0,exval=0,var=0,ev=0,p,S=0,S1=0,TP=0,Rinit[NumAll],Save=0;
	double Sm[NumAll];	
	double Sall[NumAll][4];	
	long ped;
	Node2 *nodes;
	REC2 *newrec;
	short Nobs;
	int genotypes[4][4];
	int ninf = 0;

	fstream outinf;
	//fstream outlog;
	outinf.open("informative.txt",ios::out);

	for(x=0;x<NumAll;x++) Sm[x]=0;
		
	for(i=0;i<NumAll;i++) Rinit[i]=0;
	for(int ii=0;ii<npedrows;ii++) index.push_back(ii);
	countAlleles(peddata,allUall,index,startpos);
	index.clear();

	pedigrees(peddata,npedrows,nped,peds,moms,dads);//identify individual families
	nnodes = (int) moms.size();	
	newrec = crerec2(0,Rinit,(double)0.0);
	
	for(i=0;i<moms.size();i++)
	{	
		mom=moms[i],dad=dads[i],ped=peds[i];; //mom and dad hold the parental ids for the current family		
		
		nuclear(peddata,npedrows,npedcols,index,folks,kids,ped,dad,mom,aff,startpos);		
		countAlleles(peddata,uall,index,startpos);

		if(uall.size()==1){
			inf++;
			Clear(uall,aff,index,folks,kids);
			continue; //When there is only one allele, not informative, avoid other complications.
		}

		for(j=0;j<kids.size();j++) 			
			kindex.push_back(index[kids[j]]);		
		countAlleles(peddata,kidsalls,kindex,startpos);
	
		nall = (int) uall.size();

		int** alls=NULL;
		int** allele=NULL;
		alls = (int**)malloc(index.size() * sizeof(int*)); // allocate memory for 2-D array
	    for (x=0; x<index.size(); x++) alls[x] = (int*)malloc(nall * sizeof(int));
		
		for(x=0;x<4;x++) for(j=0;j<4;j++) genotypes[x][j]=0,possgens[x][j]=0;
				
		alleles(alls,index,uall,peddata,startpos);//startpos is 6 for 1st two alleles, 8 for next two.
		
		/*for(j=0;j<index.size();j++){
			for(int icol = 0; icol < npedcols; icol++)
				outfile <<peddata[index[j]][icol] <<" ";
			outfile <<endl;
		}*/
		
		//Finds possible genotypes of offspring based on parents
		type2(alls,uall,genotypes,folks,kids,homKid,kidsalls,Nobs);
		params(genotypes,ngens,possgens,gennum,homkids,homfolk,alls,nall,kids,folks);
		int mode = 1;
		
		if(mode==1){//BIALLELIC case.
			int skip=0,indA=-1;
			for(j=0;j<uall.size();j++) {
				int q=uall[j];
				if(uall[j]==all) indA=j;//all is the allele #, indA is its index in uall
			}		
			if(indA==-1) skip=1;//Not informative for allele all.			
			if(uall.size()==1) skip=1;
			if(kids.size()==1 && folks.size()<2) skip=1;
			if(skip==1){
				inf++;
				Clear(uall,aff,index,folks,kids);
				continue; //When there is only one allele, not informative, avoid other complications.
			}
			double S2=stat2(aff,alls,kids,mod,S,nall,indA,T,possgens,gennum,ngens,folks,Nobs,homkids,homfolk);
			S+=S2;
			S1+=S2;
			Save=0;
			if(T.size()<2 && kids.size()>2 && folks.size()<2 && homfolk==0 && ngens==2){
				T.clear();
			//Ok, in the 2 alleles, two genotypes, 3+ kids case, I need to find more informative families.
			//if(homkids==1 && homfolk==0 && nall==2 && kids.size()>2 && ngens==2 && folks.size()<2){
				Save=0;
				short ok=moreinf(aff,alls,kids,mod,S,nall,indA,T,possgens,gennum,ngens,folks,Nobs,homkids,homfolk,Save);
				T.clear();
				if(ok==1){
					S2=stat2(aff,alls,kids,mod,S,nall,indA,T,possgens,gennum,ngens,folks,Nobs,homkids,homfolk);
					S+=S2;				
					S1+=Save;
				}
			}
			
			if(T.size()<2){ //Uninformative (will be cleared - T.size() will equal zero), so remove.
				//outfile <<"\nUniformative.";
				free(alls);
				alls = NULL;
				inf++;
				Clear(uall,aff,affK,folks,kids);
				Clear(T,homKid,kidsalls,kindex,index);
				gennum.clear();
				stpos.clear();
				continue;
			}
		}		
		outinf <<"\nInformative: " <<ped <<", (" << dad <<", " << mom << ")";;

		nodes=NDvector2(1,2);			//Create a vector of nnodes nodes
		
		for(j=0;j<kids.size();j++) affK.push_back(aff[kids[j]]);
		double Sobs=0;
		Sobs=S;
		double t = (double) T.size();
		double L = log(t);
		TP+=L; //Since all outcomes are equally likely, total prob. is simply augmented by the number of possible outcomes.

		//Set all values to first of last family,spj and lpj restart at 0.
		nodes[1].setNode2(TP,NULL);
		nodes[2].setNode2(0,NULL);		
				
		nodes[1].rec=newrec;//Store the first node so that it can be the last node of the next family.
		dist(nodes,T,Sall,mode,nall);

		newrec=nodes[2].rec;
		
		for (int free_rec=1; free_rec<2; free_rec++) {
			if (nodes[free_rec].rec != NULL)
				freerec2(nodes[free_rec].rec);
		}
		free_NDvector2(nodes,1,nnodes);				

		free(alls);
		alls = NULL;		
		Clear(uall,aff,affK,folks,kids);
		Clear(T,homKid,kidsalls,kindex,index);
		gennum.clear();
	}
	
	moment2(newrec,TP,exval,variance);
	var=variance-pow(exval,2); //Find moments
	ev=exval;

	p=pvalue2(exval,var,TP,newrec,S1);//Find p-value  NOTE: S1 uses the average from the re-informative families!!!!
	int numfam = (int) moms.size(); //Count nuclear families
	double Z=(S1-ev)/sqrt(var);  //Z score for RL
	

	//newrec and tNode need to be freed.
	freerec2(newrec);	
	ninf+=(numfam-inf);

	if(cline == 0)
	{
		cout <<"\n\nMarker: " ;
		int letter = 0;
		while(markernames[marker - 1][letter] != 0) cout <<markernames[marker - 1][letter], letter++;
		cout <<", Allele " << all <<", Inf fams: " << ninf ;
		if(mod == 1) cout <<", additive inheritance.";
		if(mod == 2) cout <<", dominant inheritance.";
		if(mod == 3) cout <<", recessive inheritance.";
		if(ninf > 0 ) cout <<"\nS: " << S << ", E(S): " << ev <<", Var(S): " << var <<", p: " << p << endl;
		else cout <<"\nS: ****, E(S): ****, Var(S): ****, p: ****" << endl;
	}
	if(logOn == 1) 
	{
		outlog <<"\n\nMarker: " ;
		int letter = 0;
		while(markernames[marker - 1][letter] != 0) outlog <<markernames[marker - 1][letter], letter++;
		outlog <<", Allele " << all <<", Inf fams: " << ninf ;
		if(mod == 1) outlog <<", additive inheritance.";
		if(mod == 2) outlog <<", dominant inheritance.";
		if(mod == 3) outlog <<", recessive inheritance.";
		if(ninf > 0 ) outlog <<"\nS: " << S << ", E(S): " << ev <<", Var(S): " << var <<", p: " << p << endl;
		else outlog <<"\nS: ****, E(S): ****, Var(S): ****, p: ****" << endl;
		
	}

	outinf << endl;
	outinf.close();
}

void network(int xlink,long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int log,char pedfile[80],char logfile[80],int curall,vint allAlls,int cline,int linkage)
{ //Since this is only the biallelic case, it is only necessary to test allele 0.
	vint index;
	int startpos = 6 + (marker - 1) * 2;
	int nuninf = 0; //Count uninformative families.
	double S = 0; //The test statistic.

	veclong pids, mids, fids; //Vector containing pedigree, mother, and father ids.
	int nped; //Number of pedigress in peddata;
	pedigrees(peddata,npedrows,nped,pids,mids,fids); //Identify families by mid, fid, and pid.  Count pedigrees.

	Node *nodes, *tNode;
	Rec *newrec;
	tNode = NDvector(1,1);
	tNode[1].setNode(0,0,0,0,0,NULL);
	newrec = crerec(0,(double) 0);
	double totprob = 0, ev = 0, ev2 = 0, variance = 0;
	fstream outinf; /*outlog,*/ 
	//if(log == 1) outlog.open(logfile,ios::app);
	
	outinf.open("informative.txt",ios::out);

	for(unsigned int ifam = 0; ifam < mids.size(); ifam ++) //Work through all nuclear families.
	{
		/*GATHER NUCLEAR FAMILY INFORMATION*/
		long mom = mids[ifam]; //Distinguish the current family.
		long dad = fids[ifam];
		long ped = pids[ifam];

		int pa = -1, ma = -1; //These are -1 if parents are missing.  Otherwise they contain the index of the respective parent in peddata.
		vint folks, kids, sons, dots, aff, sex, homKid, kidsalls;  //Vectors containing familial indices and affected status.
		nuclear(peddata,npedrows,index,folks,kids,ped,dad,mom,aff,startpos,sons,dots,pa,ma,sex);

		int skip = 0; //skip equal 1 when families are uninformative (quick checks)
		if(index.size() == 0) skip = 1; //No family members.

		vint famalls;  //List of the alleles observed in the family.
		countAlleles(peddata, famalls, index, startpos);

		int nalls = (int) famalls.size();
		if(nalls < 2) skip = 1; //Only one allele in the family => not informative.
		if(kids.size() == 0 ) skip = 1;
		if(kids.size() < 2 && folks.size() < 2) skip = 1; //Only one parent and one child (or less of either).

		int obsgenos[MaxFamSize][2];	//Contains the observed genotypes of the family members.
		int minAx[2], maxAx[2]; //Minimum & maximum values of both alleles for daughters and for sons.
		int minMx[3], maxMx[3]; //Minimum & maximum totals of both alleles for daughters and for sons and overall.
		vint minAg, maxAg, minMg, maxMg; //g for general. The above are for X.
		//The third row of all 4 of the mins and maxes is overall.
		int homdot = -1;	//Indicates whether a homozygous daughter has been observed (-1 means no, 0 and 1 reference alleles).
		int genson[2];		//Contains the possible genotypes for a son in this family. There are two possible alleles.
		int gendot[2][2];	//Contains the possible genotypes for a daughter in this family. There are four possible genotypes.
		int genotypes[4][4];
		int ngens = 0;
		int** allele=NULL;
		if(skip != 1)
		{
/*IDENTIFY NETWORK PARAMETERS*/
			//The current allele (curall) will always be stored in column 1!
			alleles(obsgenos,index,allAlls,peddata,startpos,curall);
			if(linkage == 1){ //The linkage == 1, xlink == 0 case will go to network2.
				if(ma != -1 && peddata[index[ma]][startpos] == peddata[index[ma]][startpos + 1]) skip = 1; //Hom mom => Not informative
				vint T; //T (as in network2) holds the possible values of S, at most 2 for the biallelic case;
				switchGens(obsgenos,sons,dots,pa,ma,T,aff,sex,kids,mod); //Get all possible values of S.
				if(T.size() < 2) skip = 1;
			}
			else{
				if(xlink == 0){
					for(int irow = 0; irow < 4; irow++) for(int icol = 0; icol < 4; icol++) genotypes[irow][icol]=0;	
					//Finds possible genotypes of offspring based on parents
					minmaxA(obsgenos,minAg,maxAg,folks,kids,genotypes,homKid);
					ngens=0;
					for(int irow = 0; irow < 4; irow++){//Count the number of possible genotypes.
						for(int icol = 0; icol < 4; icol++){
							if(genotypes[irow][icol] == 1) ngens++;
							if(genotypes[irow][icol] == 1 && irow == icol) ngens++; //If hom., counts as two.
						}
					}
					ngens = ngens/2;
					//Finds possible row margins of tables
					minmaxm(minAg,maxAg,minMg,maxMg,obsgenos,kids,folks,aff,nalls,homKid,genotypes,ngens);	
				}
				if(xlink == 1)
				{
					homdot = -1;
					int genok = minmaxX(obsgenos, minAx, maxAx, pa, ma, sons, dots, genson, gendot, homdot, minMx, maxMx);
					if(genok == 0) {
						if(cline == 0) cout <<"\nWarning: Ped " << ped <<" contains incompatible genotypes.";
						if(log == 1) outlog <<"\nWarning: Ped " << ped <<" contains incompatible genotypes.";		
						skip = 1;
					}
				}
			}
		} //skip may become 1 during the if, in which case it is caught in the next statement.

		if(skip == 1) //Don't process families that have been identified as not informative.
		{ //Reset parameter values.
			nuninf++; //Count non-informative families.
			Clear(famalls,index,folks,homKid,kidsalls);
			Clear(sons,dots,kids,aff,sex); 
			Clear(minAg,maxAg,minMg,maxMg,maxMg);
			homdot = -1;
			//cout <<"\nNot informative: " <<ped;
			continue;
		}

		double Stemp = statistic(obsgenos,aff,kids,mod,sex,xlink); //Calculate the test statistic. (This will be the same regardless of the hypothesis.)
		
		/*BUILD THE NETWORK*/
		int K = (int) kids.size();
		//if(linkage == 0)
		//{//Build the network to test the null hypothesis that there is no linkage and no association.
			vint stage, cell, B, AA, BB; //These vectors will describe the network.
			stage.push_back(0), cell.push_back(0), B.push_back(0), AA.push_back(0), BB.push_back(0);
			if(xlink == 1) buildX(obsgenos,stage,cell,minAx,maxAx,minMx,maxMx,homdot,ma,pa,sons,dots); //Funtion that builds the network.
			else if(xlink == 0)  buildG(minMg,maxMg,K,stage,cell,B,minAg,maxAg,homKid,genotypes,AA,BB,ngens,folks);
			//cout << endl << "Ped: " << ped << endl;
			//for(unsigned int x = 0; x < stage.size(); x++)	cout <<"(" <<stage[x] <<"," << cell[x]  <<")" <<endl;

			vint stpos, endpos; //Starting and ending positions of network stages.
			vint affK;
			int count = 0, nkids = (int) kids.size();
			int nstage = nkids + 1;
			stpos.push_back(0);
			for(int istage = 0; istage < nstage; istage++)
			{
				for(unsigned int j = 0; j < stage.size(); j++) if(stage[j] == istage) count++;
				stpos.push_back(count);
				endpos.push_back(count - 1);
			}
			endpos.push_back( (int) stage.size() - 1);

			/*PROCESS THE NETWORK BACKWARD*/
			vecd fact=faclog(2*K+1);
			int nnodes = (int) stage.size();
			nodes=NDvector(1,nnodes);
			nodes[stpos[nkids+1]+1].setNode(0,0,tNode[1].ev,tNode[1].var,tNode[1].tp,NULL);
			int genma[2] = {0,0};
			int genpa = 0; //genpa is not used in this function.
			if(xlink == 0) 
			{
				allele = (int**)malloc(stage.size() * sizeof(int*)); // allocate memory for 2-D array
				for (int x=0; x< (int) stage.size(); x++) allele[x] = (int*)malloc(nalls * sizeof(int)); //This is clumsy, but I need all allele info in one place.
				for(int x=0;x< (int) stage.size();x++) {
					allele[x][0]=cell[x];
					allele[x][1]=B[x];
				}
				for(int j=0;j<(int) kids.size();j++) affK.push_back(aff[kids[j]]);	
				affK.push_back(0); //For the final stage.
				backwardG(K+1,maxMg,minMg,nnodes,nodes,fact,stage,folks,allele,stpos,endpos,affK,minAg,maxAg,mod,homKid,AA,BB,ngens); 
			}
			else if(xlink == 1)
			{
				mapa(ma,pa,genma,genpa,obsgenos); //Find parental genotypes.
				backwardX(nstage,nnodes,nodes,minAx,maxAx,stage,cell,stpos,endpos,genma,ma,pa,homdot,sons,dots,aff,mod);
			}

			if(nodes[1].lpj == nodes[1].spj)
			{ //The family is not informative.
				nuninf++; //Count uninformative families.
				Clear(stage,cell,aff,sex,stpos);
				Clear(endpos,sons,dots,kids,folks);
				Clear(AA,BB,minAg,maxAg,minMg);
				maxMg.clear();famalls.clear();index.clear();B.clear(),affK.clear();			
				homdot = -1;
				free_NDvector(nodes, 1, nnodes);
				//cout <<"\nNot informative: " <<ped;
				continue;
			}

			S += Stemp; //If the family is informative, augment S.
			outinf <<"\nInformative: " <<ped <<", (" << dad <<", " << mom << ")";

			/*PROCESS THE NETWORK FOREWARD*/
			nodes[1].rec = newrec;

			if(xlink == 0) forwardG(maxMg,minMg,nnodes,nstage,nodes,stpos,endpos,fact,folks,affK,minAg,maxAg,stage,allele,mod,AA,BB,ngens,homKid);
			else if(xlink == 1) forwardX(nstage,nnodes,nodes,minAx,maxAx,minMx,maxMx,stage,cell,stpos,endpos,genma,ma,pa,homdot,sons,dots,aff,mod);
			totprob = addlog(totprob, nodes[1].tp);
			tNode[1].setNode(0,0,nodes[1].ev,nodes[1].var, nodes[1].tp, NULL);
			newrec = nodes[nnodes].rec;
		//}//End linkage == 0;

		for(int free_rec = 1; free_rec < nnodes; free_rec++)
		{
			if(nodes[free_rec].rec != NULL)
				freerec(nodes[free_rec].rec);
		}
		Clear(stage,cell,aff,sex,stpos);
		Clear(endpos,sons,dots,kids,folks);
		Clear(AA,BB,minAg,maxAg,minMg);
		maxMg.clear();famalls.clear();index.clear();B.clear();affK.clear();	
		homdot = -1;
		free_NDvector(nodes,1,nnodes);		
	}

	/*COMPUTE MOMENTS AND P-VALUE*/
	moment(newrec, tNode, ev, ev2);
	double var = ev2 - (ev * ev);

	double p = pvalue(ev,var,tNode,newrec,S);
	int numfams = (int) mids.size();
	int ninformative = numfams - nuninf;

	if(newrec != NULL) freerec(newrec);
	free_NDvector(tNode,1,1);


	if(cline == 0)
	{
		cout <<"\n\nMarker: " ;
		int letter = 0;
		while(markernames[marker - 1][letter] != 0) cout <<markernames[marker - 1][letter], letter++;
		cout <<", Allele " << allAlls[curall] <<", Inf fams: " << ninformative ;
		if(mod == 1) cout <<", additive inheritance.";
		if(mod == 2) cout <<", dominant inheritance.";
		if(mod == 3) cout <<", recessive inheritance.";
		if(ninformative > 0 ) cout <<"\nS: " << S << ", E(S): " << ev <<", Var(S): " << var <<", p: " << p << endl;
		else cout <<"\nS: ****, E(S): ****, Var(S): ****, p: ****" << endl;
	}
	if(log == 1) 
	{
		outlog <<"\n\nMarker: " ;
		int letter = 0;
		while(markernames[marker - 1][letter] != 0) outlog <<markernames[marker - 1][letter], letter++;
		outlog <<", Allele " << allAlls[curall] <<", Inf fams: " << ninformative ;
		if(mod == 1) outlog <<", additive inheritance.";
		if(mod == 2) outlog <<", dominant inheritance.";
		if(mod == 3) outlog <<", recessive inheritance.";
		if(ninformative > 0 ) outlog <<"\nS: " << S << ", E(S): " << ev <<", Var(S): " << var <<", p: " << p << endl;
		else outlog <<"\nS: ****, E(S): ****, Var(S): ****, p: ****" << endl;
		
	}
	outinf << endl;
	outinf.close();

	return;
}
void networkX2(int xlink,long **peddata,int npedrows,int npedcols,char markernames[][buffsize],int marker,int mod,int logOn,char pedfile[80],char logfile[80],int curall,vint allAlls,int cline,int linkage)
{  //The linkage == 1, xlink == 0 case will go to network2.
	vint index, esses;
	int startpos = 6 + (marker - 1) * 2;
	int nuninf = 0; //Count uninformative families.
	double S = 0; //The test statistic.

	veclong pids, mids, fids; //Vector containing pedigree, mother, and father ids.
	int nped; //Number of pedigress in peddata;
	pedigrees(peddata,npedrows,nped,pids,mids,fids); //Identify families by mid, fid, and pid.  Count pedigrees.

	Node *nodes, *tNode;
	Rec *newrec;
	newrec = crerec(0,(double) 0);
	double totprob = 0, ev = 0, ev2 = 0, variance = 0;
	fstream  outinf; //outlog,
	//if(logOn == 1) outlog.open(logfile,ios::app);

	outinf.open("informative.txt",ios::out);
	int first = 0; //Designates the first informative family, for adding probs.

	for(unsigned int ifam = 0; ifam < mids.size(); ifam ++) //Work through all nuclear families.
	{
		/*GATHER NUCLEAR FAMILY INFORMATION*/
		long mom = mids[ifam]; //Distinguish the current family.
		long dad = fids[ifam];
		long ped = pids[ifam];

		int pa = -1, ma = -1; //These are -1 if parents are missing.  Otherwise they contain the index of the respective parent in peddata.
		vint folks, kids, sons, dots, aff, sex, homKid, kidsalls;  //Vectors containing familial indices and affected status.
		nuclear(peddata,npedrows,index,folks,kids,ped,dad,mom,aff,startpos,sons,dots,pa,ma,sex);

		int skip = 0; //skip equal 1 when families are uninformative (quick checks)
		if(index.size() == 0) skip = 1; //No family members.

		vint famalls;  //List of the alleles observed in the family.
		countAlleles(peddata, famalls, index, startpos);

		int nalls = (int) famalls.size();
		if(nalls < 2) skip = 1; //Only one allele in the family => not informative.
		if(kids.size() == 0 ) skip = 1;
		if(kids.size() < 2 && folks.size() < 2) skip = 1; //Only one parent and one child (or less of either).
		if(ma != -1 && peddata[index[ma]][startpos] == peddata[index[ma]][startpos + 1]) skip = 1; //Hom mom => Not informative
		
		int obsgenos[MaxFamSize][2];	//Contains the observed genotypes of the family members.
		//The current allele (curall) is stored in the first column!
		int homdot = -1;	//Indicates whether a homozygous daughter has been observed (-1 means no, 0 and 1 reference alleles).
		alleles(obsgenos,index,allAlls,peddata,startpos,curall);
		
		switchGens(obsgenos,sons,dots,pa,ma,esses,aff,sex,kids,mod); //Get all possible values of S.
		if(esses.size() < 2) skip = 1;
		if(skip == 1) //Don't process families that have been identified as not informative.
		{ //Reset parameter values.
			nuninf++; //Count non-informative families.
			Clear(famalls,index,folks,homKid,kidsalls);
			Clear(sons,dots,kids,aff,sex);
			esses.clear();
			homdot = -1;
			//cout <<"\nNot informative: " <<ped;
			continue;
		}		

		S += statistic(obsgenos,aff,kids,mod,sex,xlink); //Calculate the test statistic. (This will be the same regardless of the hypothesis.)
		outinf <<"\nInformative: " <<ped <<", (" << dad <<", " << mom << ")";;

		double t = (double) esses.size(); //Check this!!!!
		if(esses.size() != 2) cout <<endl << ped <<": " << esses.size();
		double L = log(t); //Check this is other case, I don't think it works.
		
		totprob += L; //log(a) + log(b) = log(ab), want probs to increase multiplicatively.

		//Set all values to first of last family,spj and lpj restart at 0.
		int nnodes = 2;
		nodes=NDvector(1,nnodes);
		nodes[1].setNode(0,0,0,0,totprob,NULL);
		nodes[2].setNode(0,0,0,0,0,NULL);		
				
		nodes[1].rec=newrec;//Store the first node so that it can be the last node of the next family.
		distX(nodes,esses);

		newrec=nodes[2].rec;
			
		for(int free_rec = 1; free_rec < nnodes; free_rec++)
		{
			if(nodes[free_rec].rec != NULL)
				freerec(nodes[free_rec].rec);
		}
		Clear(esses,index,aff,sex,famalls);
		sons.clear();dots.clear();kids.clear();folks.clear();
		homdot = -1;
		free_NDvector(nodes,1,nnodes);		
	}

	/*COMPUTE MOMENTS AND P-VALUE*/
	tNode = NDvector(1,1);
	tNode[1].setNode(0,0,0,0,totprob,NULL);
	moment(newrec, tNode, ev, ev2);
	double var = ev2 - (ev * ev);
	double p = pvalue(ev,var,tNode,newrec,S);
	int numfams = (int) mids.size();
	int ninformative = numfams - nuninf;

	if(newrec != NULL) freerec(newrec);
	free_NDvector(tNode,1,1);

	if(cline == 0)
	{
		cout <<"\n\nMarker: " ;
		int letter = 0;
		while(markernames[marker - 1][letter] != 0) cout <<markernames[marker - 1][letter], letter++;
		cout <<", Allele " << allAlls[curall] <<", Inf fams: " << ninformative ;
		if(mod == 1) cout <<", additive inheritance.";
		if(mod == 2) cout <<", dominant inheritance.";
		if(mod == 3) cout <<", recessive inheritance.";
		if(ninformative > 0 ) cout <<"\nS: " << S << ", E(S): " << ev <<", Var(S): " << var <<", p: " << p << endl;
		else cout <<"\nS: ****, E(S): ****, Var(S): ****, p: ****" << endl;
	}
	if(logOn == 1) 
	{
		outlog <<"\n\nMarker: " ;
		int letter = 0;
		while(markernames[marker - 1][letter] != 0) outlog <<markernames[marker - 1][letter], letter++;
		outlog <<", Allele " << allAlls[curall] <<", Inf fams: " << ninformative ;
		if(mod == 1) outlog <<", additive inheritance.";
		if(mod == 2) outlog <<", dominant inheritance.";
		if(mod == 3) outlog <<", recessive inheritance.";
		if(ninformative > 0 ) outlog <<"\nS: " << S << ", E(S): " << ev <<", Var(S): " << var <<", p: " << p << endl;
		else outlog <<"\nS: ****, E(S): ****, Var(S): ****, p: ****" << endl;		
	}
	outinf << endl;
	outinf.close();

	return;
}
void distX(Node *nodes,vint T) //Change this to distX2 and fix!!
{		
	int numrec; //# of records
	unsigned int i;
	double npr,p,r=0;
	vint diff,rj,lowlim,uplim,x;		
	REC *newrec,*currec,*nxt,*curr; //create pointers for traversing the network.
	numrec=1;
	currec=nodes[1].rec;

	while (currec != NULL) 
	{
		for(i=0;i<T.size();i++){														
			r=currec->pastr+T[i];	//calculate rank length
			p=0.0;						
			if (currec->pastp<0.0000001) npr=p;	//calculate prob length isn't this redundant?
			else npr=currec->pastp+p;							
			newrec=crerec(r,npr);
			numrec++;
			if (nodes[2].rec == NULL)		//If the next record is null, make it the new one
				nodes[2].rec = newrec;
			else 
			{
				if (nodes[2].rec->pastr > newrec->pastr){ //Else if the new r is less than the old one
					newrec->nextrec = nodes[i+1].rec;		//the new record points to the old
					nodes[2].rec = newrec;
				}
				else{ 
					curr=nodes[2].rec;		//otherwise, 
					nxt=curr->nextrec;
					while (nxt != NULL){			//move through until pointing to null
						if (r == curr->pastr || (nxt != NULL && (r < nxt->pastr)))
								break;
						curr=nxt;
						nxt=curr->nextrec;
					}
					if (r == curr->pastr){ //if the record is already there, augment the prob and remove rec
						curr->pastp=addlog(curr->pastp,newrec->pastp);
						free(newrec);
						numrec--;
					}
					else {
						newrec->nextrec=nxt;	//otherwise, add the record
						curr->nextrec=newrec;
					}
				}
			}			
		}
			currec=currec->nextrec;			
	}
}
void switchGens(int obsgenos[][2],vint sons,vint dots,int pa,int ma,vint &T,vint aff,vint sex,vint kids,int mod)
{
	int switchKids[2] = {0,0};
	int genpa = 0;
	int genma[2] = {0,0};
	int switchgenos[MaxFamSize][2];
	int homdot = -1; //Index of hom genotype
	mapa(ma,pa,genma,genpa,obsgenos);

	int Stemp = (int) statistic(obsgenos,aff,kids,mod,sex,1);
	T.push_back(Stemp); //One possible value of T is the observed value.

	/*FIND OUT WHICH GENOTYPES CAN BE SWITCHED*/
	//Check to see if there are more T values.
	
	for(int idot = 0; idot < (int) dots.size(); idot++) //Check homdot .
	{//(there can be at most 1 homozygous genotype)
		if(obsgenos[dots[idot]][0] == 2) homdot = 0; //Two genos among dots is sufficient.
		else if(obsgenos[dots[idot]][1] == 2) homdot = 1; //Identify hom dot.
		if(homdot != -1) continue;
	}
	if(pa != -1 && ma != -1) switchKids[0] = switchKids[1] = 1; //Neither parent missing.
	else if(pa != -1 && ma == -1) //Mother missing, father known.
	{ //Look for two genos among sons OR dots, or het dot and pa geno in son or hom dot and non-pa geno in son.
		if(dots.size() > 0)
		{
			int nall1 = obsgenos[dots[0]][0];
			for(int idot = 0; idot < (int) dots.size(); idot++)//Check for two genos among dots. 
				if(obsgenos[dots[idot]][0] != nall1) switchKids[0] = switchKids[1] = 1; 
		}
		int sonGens[2] = {0,0};
		if(sons.size() > 0)
		{
			int nall1 = obsgenos[sons[0]][0];
			
			for(int ison = 0; ison < (int) sons.size(); ison++)
			{
				if(obsgenos[sons[ison]][0] != nall1) switchKids[0] = switchKids[1] = 1; //Two genos among sons is sufficient.
				if(obsgenos[sons[ison]][0] == 2) sonGens[0] = 1;
				if(obsgenos[sons[ison]][1] == 2) sonGens[1] = 1;
			}
		}
		if(homdot != -1 && sonGens[1 - pa] == 1) switchKids[0] = switchKids[1] = 1;
		if(homdot == -1 && sonGens[pa] == 1) switchKids[0] = switchKids[1] = 1;
	}
	else if(pa == -1 && ma != -1)//If mother is known, she is necessarily het in an informative family.
	{
		switchKids[1] = 1;
		if(dots.size() > 1) {
			int nall1 = obsgenos[dots[0]][0];
			for(int idot = 1; idot < (int) dots.size(); idot++) //Start from 0 to check homdot.
				if(obsgenos[dots[idot]][0] != nall1) switchKids[0] =  1; //Two genos among dots is sufficient.
		}
	}
	else if(pa == -1 && ma == -1)
	{
		if(dots.size() > 0) {
			int nall1 = obsgenos[dots[0]][0];		
			for(int idot = 1; idot < (int) dots.size(); idot++) //Start from 0 to check homdot.
				if(obsgenos[dots[idot]][0] != nall1) switchKids[0] = 1; //Two genos among dots is sufficient.
		}
		if(sons.size() > 0){
			int nall1 = obsgenos[sons[0]][0];		
			for(int ison = 1; ison < (int) sons.size(); ison++)
				if(obsgenos[sons[ison]][0] != nall1) switchKids[1] = 1; //Two genos among sons is sufficient.
		}
	}
	/*SWITCH GENOS, PUT SWITCHED GENOS INTO SWITCHGENOS*/
	if(switchKids[0] + switchKids[1] == 0)
	{
		for(int iall = 0; iall < 2; iall++)
		{
			if(ma != -1) switchgenos[ma][iall] = obsgenos[ma][iall]; //Parents don't matter, copy obsgenos.
			if(pa != -1) switchgenos[pa][iall] = obsgenos[pa][iall];
			for(int idot = 0; idot < (int) dots.size(); idot++) switchgenos[dots[idot]][iall] = obsgenos[dots[idot]][iall];
			for(int ison = 0; ison < (int) sons.size(); ison++) switchgenos[sons[ison]][iall] = obsgenos[sons[ison]][iall];
		}
	}
	else if(switchKids[0] + switchKids[1] > 0) //If either sons or dots can switch compute another value of the test statistic.
	{
		for(int iall = 0; iall < 2; iall++)
		{
			if(ma != -1) switchgenos[ma][iall] = obsgenos[ma][iall]; //Parents don't matter, copy obsgenos.
			if(pa != -1) switchgenos[pa][iall] = obsgenos[pa][iall];	
		}
		for(int idot = 0; idot < (int) dots.size(); idot++)
		{
			if(switchKids[0] == 1) //If daughters can switch.
			{//obsgenos contains counts of alleles.
				if(obsgenos[dots[idot]][0] == 2 || obsgenos[dots[idot]][1] == 2) 
				{//From homozygous to heterozygous.
					switchgenos[dots[idot]][0] = 1;
					switchgenos[dots[idot]][1] = 1;
				}					
				else if(obsgenos[dots[idot]][0] == 1)
				{
					int homAll = -1; //Figure out which is allele for which a dot can be homozygous.
					if(pa != -1) homAll = genpa;  //If the father is kown, this is his genotype.
					else homAll = homdot;	//Otherwise, a hom dot must have been observed.
					if(homAll != -1)
					{
						switchgenos[dots[idot]][homAll] = 2;
						switchgenos[dots[idot]][1-homAll] = 0;
					}	
				}
			}				
			else
			{
				switchgenos[dots[idot]][0] = obsgenos[dots[idot]][0];
				switchgenos[dots[idot]][1] = obsgenos[dots[idot]][1];
			}
		}
			
		for(int ison = 0; ison < (int) sons.size(); ison++)
		{
			if(switchKids[1] == 1)
			{//obsgenos contains counts of alleles.
				if(obsgenos[sons[ison]][0] == 2) switchgenos[sons[ison]][0] == 0, switchgenos[sons[ison]][1] == 2;
				else if(obsgenos[sons[ison]][1] == 2) switchgenos[sons[ison]][0] == 2, switchgenos[sons[ison]][1] == 0;											
			}
			else
			{
				switchgenos[sons[ison]][0] = obsgenos[sons[ison]][0];
				switchgenos[sons[ison]][1] = obsgenos[sons[ison]][1];
			}
		}
	}
	Stemp = (int) statistic(switchgenos,aff,kids,mod,sex,1);
	if(Stemp != T[0]) T.push_back(Stemp); //One possible value of T is the observed value.
}

void forwardG(vint maxm,vint minm,long nnodes,int K,Node *nodes,vint stpos,vint endpos,vecd fact,vint folks,vint aff,vint min,vint max,vint stage,
			  int** allele,int mod,vint AA,vint BB,int ngens,vint homKid) 
{		
	int pos,j,numrec,l; //position, higher limit, lowerlimit, rank, stage, , # of records
	int i,goOn,k,c;
	int low,y,sumall,tmax,tmin;
	double npr,p,ipl,r;
	vint diff,rj,lowlim,uplim,x;
	double ev=nodes[1].ev;
	
	REC *newrec,*currec,*nxt,*curr; //create pointers for traversing the network.
//	cout<< endl << "stpos and endpos:" <<endl;
//	for(i=0;i<stpos.size();i++) cout << stpos[i] << " " <<endpos[i] <<endl;	
	numrec=1;
	for(i=0;i< (int) min.size();i++) diff.push_back(max[i]-min[i]);
	for (j=0;j<=K-1;j++){ //Cycle through K stages of the network.
		for (pos=stpos[j];pos<=endpos[j];pos++){	//Cycle through all nodes at stage j.
			//mj=cell[pos];
			//lj=last[pos];
			rj.clear();
			for(i=0;i< 2;i++) rj.push_back(allele[pos][i]);
			if (nodes[pos+1].rec == NULL) //If no contributing path emanates from this node, move on.
				continue;			//causes loop to stop current iteration and begin next one 

//VISIT ALL SUCCESSOR NODES
			lowlim.clear();
			uplim.clear();
			for(i=0;i< 2;i++){
				tmax=allele[stpos[j+1]][i];
				tmin=allele[stpos[j+1]][i];
				for(c=stpos[j+1];c<=endpos[j+1];c++){
					if(allele[c][i]>tmax) tmax=allele[c][i];
					if(allele[c][i]<tmin) tmin=allele[c][i];
				}
				low=IMAX(rj[i]+min[i],tmin);
				if(low>maxm[i]) low=maxm[i];
				lowlim.push_back(low);	//Minimum value of a successor
				uplim.push_back(IMIN(rj[i]+max[i],tmax));	//Maximum value of a successor
			}
			currec=nodes[pos+1].rec;

			while (currec != NULL) 
			{
				int w1=stpos[j+1];
				int w2=endpos[j+1];
				for(i=stpos[j+1];i<=endpos[j+1];i++){
//Cycle through all nodes at the next stage, check to see which of these are successor nodes (goOn==1).
					goOn=1;
					sumall=0;
					for(k=0;k< 2;k++){
						low=lowlim[k];
						int up=uplim[k];
						if(up<low)
						{
							int temp=up;
							up=low;
							low=temp;
						}
						if(low<=allele[i][k] && allele[i][k]<=up) ;
						else goOn=0;
						sumall+=abs(allele[i][k]-rj[k]);
			
						if(allele[i][k]-rj[k]<min[k] || allele[i][k]-rj[k]>max[k]) goOn=0;
					}
					if(sumall>2)goOn=0;
					int aa=AA[pos];
					int bb=BB[pos];

					x.clear();
					for(l=0;l< 2;l++) x.push_back(allele[i][l]-rj[l]);
					if(homKid.size()>0){ 
						if(allele[i][homKid[0]]-rj[homKid[0]]==2) aa+=1 ; //Check to see that aa is correctly augmented.
					}
					if(homKid.size()==2){
						if(allele[i][homKid[1]]-rj[homKid[1]]==2) bb+=1;
					}

					if(aa==AA[i] && bb==BB[i]) ;
					else goOn=0;
					
					//if((lowlim<=cell[i] && cell[i]<=uplim) && (last[i]-lj==((cell[i]-mj)%2))) goOn=1;
//This step above checks to see which nodes are successor nodes, if we are at the stage before the terminal node,
//all nodes have the same single successor whether it meets these criteria or not, so in that case goOn==1 regardless.
					if(j==K-1) goOn=1; 
										
					if(goOn==1){
					
						y=x[0];
						if(mod==2) if(y!=0) y=1;
						if(mod==3){
							if(y==2) y=1;
							else y=0;
						}
						ipl=y*aff[j]; //aff is just for kids.
																		
						r=currec->pastr+ipl;	//calculate rank length
						
						if(j==K-1) p=0.0;
						else p=prbar0(x[0]-min[0],fact,diff[0]);						
							
						if (currec->pastp<0.0000001) npr=p;	//calculate prob length isn't this redundant?
						else npr=currec->pastp+p;							
						newrec=crerec(r,npr);
						numrec++;
						if (nodes[i+1].rec == NULL)		//If the next record is null, make it the new one
							nodes[i+1].rec=newrec;
						else if (nodes[i+1].rec->pastr > newrec->pastr) //Else if the new r is less than the old one
						{
							newrec->nextrec = nodes[i+1].rec;		//the new record points to the old
							nodes[i+1].rec = newrec;
						}
						else 
						{
							curr=nodes[i+1].rec;		//otherwise, 
							nxt=curr->nextrec;
							while (nxt != NULL)			//move through until pointing to null
							{
								if (r == curr->pastr || (nxt != NULL && (r < nxt->pastr)))
										break;
								curr=nxt;
								nxt=curr->nextrec;
							}
							if (r == curr->pastr)//if the record is already there, augment the prob and remove rec
							{		
								curr->pastp=addlog(curr->pastp,newrec->pastp);
								free(newrec);
								numrec--;
							}
							else 
							{
								newrec->nextrec=nxt;	//otherwise, add the record
								curr->nextrec=newrec;
							}
						}
					}
				}										
				currec=currec->nextrec;
			}
		}
	}	
}


void backwardG(int J,vint maxm,vint minm,long nnodes,Node *nodes,vecd fact,vint stage,vint folks,int** allele,vint stpos,vint endpos,vint aff,
			   vint min,vint max,int mod,vint homKid,vint AA,vint BB,int ngens)
{
	//I will refer to the extra node for each network as the end node, 
	//the nodes one stage before are the terminal nodes.
	int npos,k,j,succ=1;
	double splj=0,lplj=0;
	//indices, shortest and longest paths, #alleles that can be transmitted,cell and last for current node
	double totprob=nodes[nnodes].tp,ev=nodes[nnodes].ev,var=nodes[nnodes].var,exx=0.0;

	void pathG(int k,int j,int K,vint maxm,vint minm,long nnodes,vint stpos,vint endpos,vint stage,vint folks,int** allele,double *exx,vecd fact,
		Node *nodes,double* splj,double *lplj,double *totprob,vint min,vint max,vint aff,double *ev,int mod,vint homKid,vint AA,vint BB,
		int ngens);

	for(j=J-1;j>=0;j--)//begin at the last stage and process through to the first
	{
		npos=stpos[j];
		if(j==J-1) //When we are at a stage preceding an end node, all rank and prob lengths will be 0 and 1 resp.
		{			
			for (k=stpos[j];k<=endpos[j];k++) 
			{
				nodes[npos+1].setNode(0,0,ev,exx,totprob,NULL);//This is a dummy node, so these values are unchanged from previous node	
				npos++;				
			}			
		}
		
		else//If we're not at the terminal nodes for a family, find the shortest and longest paths and the total prob for the node
		{
			
			for (k=stpos[j];k<=endpos[j];k++)
			{//Find spl, lpl, and totprob for the node
				pathG(k,j,J,maxm,minm,nnodes,stpos,endpos,stage,folks,allele,&exx,fact,nodes,&splj,&lplj,&totprob,min,max,aff,&ev,mod,
					homKid,AA,BB,ngens);
				nodes[npos+1].setNode(splj,lplj,ev,exx,totprob,NULL);
				npos++;
			}
		}					
	}	
return;
}

void pathG(int pos,int j,int K,vint maxm,vint minm,long nnodes,vint stpos,vint endpos,vint stage,vint folks,int** allele,double *var,vecd fact,
		   Node *nodes,double *splj,double *lplj,double *totprob,vint min,vint max,vint aff,double *eval,int mod,vint homKid,vint AA,vint BB,int ngens)
{
	double ipl,ipl2,ispj,ispj2,ilpj,ilpj2;
	int i,l,k,num,go,sumall; 
	//Max and min values of successor nodes, shortest and longest paths, length of current path
	double pr,prob,tp,ev,exsqi,iev,iev2,iexx,iexx2,y;
	vint diff,lowlim,uplim,x,rj;
	int aa,bb,tmax,tmin,c;
	
	for(i=0;i< 2;i++) rj.push_back(allele[pos][i]);
	for(i=0;i< (int) min.size();i++) diff.push_back(max[i]-min[i]);
	
	for(i=0;i< 2;i++){//This doesn't work for the biallelic case, because I need maxhet.
		tmax=allele[stpos[j+1]][i];
		tmin=allele[stpos[j+1]][i];
		for(c=stpos[j+1];c<=endpos[j+1];c++){
			if(allele[c][i]>tmax) tmax=allele[c][i];
			if(allele[c][i]<tmin) tmin=allele[c][i];
		}
		lowlim.push_back(IMAX(rj[i]+min[i],tmax));	//Minimum value of a successor
		uplim.push_back(IMIN(rj[i]+max[i],tmin));	//Maximum value of a successor		
	}
	
	num=0;
	tp=ev=exsqi=0.0;

	for(i=stpos[j+1];i<=endpos[j+1];i++)//cycle through all nodes at this stage
	{
		go=1;
		sumall=0;
		for(k=0;k< 2;k++){
			int low=lowlim[k];
			int up=uplim[k];
			if(up<low){//I don't know if this is valid, I'm just getting desperate.
				int temp=up;
				up=low;
				low=temp;
			}
			int a=allele[i][k];
			if(low<=allele[i][k] && allele[i][k]<=up) ;
			else go=0;
			sumall+=abs(allele[i][k]-rj[k]);			
			if(allele[i][k]-rj[k]<min[k] || allele[i][k]-rj[k]>max[k]) go=0;
		}
		if(sumall>2) go=0;//Make sure the difference is only 2 alleles.
		if(go==0) continue;
		aa=AA[pos];
		bb=BB[pos];

		x.clear();		
		for(l=0;l<2;l++) x.push_back(allele[i][l]-rj[l]);			
		
		if(homKid.size()>0){
			if(allele[i][homKid[0]]-rj[homKid[0]]==2) aa+=1 ; //Check to see that aa is correctly augmented.
		}
		if(homKid.size()==2){
			if(allele[i][homKid[1]]-rj[homKid[1]]==2) bb+=1;
		}
		
		if(aa==AA[i] && bb==BB[i]) ;
		else go=0;
				
		if(go==1)		
		{
			num++;	
			y=x[0]; //This is the multiple alleles in the biallelic setting.
			if(mod==2) if(y!=0) y=1; //dominant case
			if(mod==3) //recessive case 
			{
				if(y==2) y=1;
				else y=0; 
			}
			
			ipl=y*aff[j]; //aff is just for kids.			
			ipl2=pow(y,2)*aff[j];//This needs work.			
			ispj=nodes[i+1].spj+ipl;
			ilpj=nodes[i+1].lpj+ipl;

			pr=prbar0(x[0]-min[0],fact,diff[0]);
			prob=pr+nodes[i+1].tp;
			iev=log(nodes[i+1].ev+ipl)+(prob);
			double temp=nodes[i+1].var+pow(nodes[i+1].ev+ipl,2);
			iexx=log(temp)+(prob);
					
			if(num>1) //when there is more than one successor node, compare path lengths to find longest and shortest.
			{				
				if (ispj2<ispj) ispj=ispj2;
				if (ilpj2>ilpj) ilpj=ilpj2;
				iev=addlog(iev,iev2);
				iexx=addlog(iexx,iexx2);
				tp=addlog(tp,prob);
			}
			else tp=prob;
			
			ev=exp(iev-tp);
			exsqi=exp(iexx-tp);				
			ispj2=ispj;
			ilpj2=ilpj;
			iev2=iev;
			iexx2=iexx;
		}		
	}
	*splj=ispj;
	*lplj=ilpj;
	*totprob=tp;
	*eval=ev;
	*var=exsqi-ev*ev;
	return;
}



void buildG(vint minm,vint maxm,int K,vint &stage,vint &A,vint &B,vint min,vint max,vint homKid,int genotypes[][4],
			vint &AA,vint &BB,int ngens,vint folks)
{//K is kids.size()
	//This needs to be cleaned up.  It has many artifacts of the multiple alleles case and could be greatly simplified.
	int OK(vint rj,vint m,int genotypes[][4],int aa,int bb,vint homKid,int j,int K,vint maxm,vint minm,vint max,int ngens,vint folks);
	int w,y,i,j,k,l,maxi,mini;
	int go,aa=0,bb=0;
	vint m,diff,minAll,maxAll,rj,type,hom;//type holds the genotype, hom keeps track of homozygous kids.
	
	for(i=0;i< (int) min.size();i++) diff.push_back(max[i]-min[i]);
	
	for(j=0; j<=K; j++)			//Add all the nodes to my list. j is the stage
	{
		for(i=0; i< (int) stage.size(); i++)
		{
			if(stage[i]==(j-1))	//succ(j,aj,bj,abj)={(j+1,w,x,y,z):mina<=w<=maxa, minb<=y<=maxb, z<=maxhet}
			{
				rj.clear();
				minAll.clear();
				maxAll.clear();				

				rj.push_back(A[i]);	//Succ(j,r1j,r2j,r3j)={(j+1, r1,j+1,r2,j+2,r3,j+3): (w, y, z)  genotypes,
				rj.push_back(B[i]);	//rij+min <=ri,j+1<= rij+max, where, 
				for(k=0;k<2;k++) {
					mini=IMAX(rj[k]+min[k], minm[k]-(K-(j))*max[k]);
					minAll.push_back(mini);
					maxi=IMIN(maxm[k]-(K-(j))*min[k], rj[k]+max[k]);
					maxAll.push_back(maxi);
				}				
				
				for(w=minAll[0];w<=maxAll[0];w++)
				{
					for(y=minAll[1];y<=maxAll[1];y++)
					{						
						m.clear();
						m.push_back(w);
						m.push_back(y);
						int tot=0;
						for(l=0;l<2;l++)
						{
							tot+=m[l]-rj[l];
						}
						if(tot<2 || (w+y)>2*j) continue;	
						
						if(homKid.size()>0 && m[homKid[0]]-rj[homKid[0]]==2) aa=AA[i]+1;//Counting AAs									
						else aa=AA[i];//This will work since there can be at most 2 homozygotes and if there are
						//2, this must be one.  The next statement will catch the other.
						if(homKid.size()==2 && m[homKid[1]]-rj[homKid[1]]==2) bb=BB[i]+1; //Can't have two homozygotes with 3 or 4 alleles.
						else bb=BB[i];								
						
						go=OK(rj,m,genotypes,aa,bb,homKid,j,K+1,maxm,minm,max,ngens,folks);
						if(go==1) {
							for(int k = 0; k < (int) stage.size(); k++){	//Look through the vector minus the most recent node, 
								if(stage[k]==j && A[k]==w && B[k]==y && AA[k]==aa && BB[k]==bb) go=0;//to get rid of any duplicate nodes.
						}	}
						if(go==1) {//If go=1, this node can be added.
							stage.push_back(j);
							A.push_back(w);
							B.push_back(y);
							AA.push_back(aa);
							BB.push_back(bb);													
	}	}	}	}	}	}	
						
	stage.push_back(j);
	A.push_back(maxm[0]);
	B.push_back(maxm[1]);
	AA.push_back(aa);
	BB.push_back(bb);
	return;
}

int OK(vint rj,vint m,int genotypes[][4],int aa,int bb,vint homKid,int j,int K,vint maxm,
	   vint minm,vint max,int ngens,vint folks)
{//K is the number of stages, K=#kids+1.
	int go,allele[4],i;
	vint type;//Type holds the genotype that is being added, it should be size 2, with each element being one allele.
	
	/*Check that Genotype is valid.*/
	for(i=0;i<2;i++) allele[i]=m[i]-rj[i]; //This is how many of each allele are added.
	for(i=0;i<2;i++){
		if(allele[i]==1) type.push_back(i);
		else if(allele[i]==2)type.push_back(i), type.push_back(i);		
	}	
	if(type.size()==2 && genotypes[type[0]][type[1]]==1) go=1; //Check to see if this genotype is valid.
	else go=0;
	if(go==0) return go; //If this genotype is not valid, there is no reason to proceed.
	if(folks.size()==2) return go;//If the parents are available, only check that gen is valid. 
	
	//Ok, this won't be pretty.  Some of it is probably redundant.  There are several more conditions to check.
	
	/*Check that there's room for homozygotes if needed.*/
	if(homKid.size()==2){
		if(j==K-2 && aa==0 && bb==0) go=0;//If we're two away and still none, too late
		else if(j==K-1 && (aa==0 || bb==0)) go=0; //At the next stage, both must be there.
	}	
	if(homKid.size()==1 && j==K-1 && aa==0 && bb==0) go=0;
	//There should be a homozygous child, but this is the last stage, so it can't happen.
	
	int room=0;	//I don't get this, don't remember why I did it, but doesn't hurt.	
	for(i=0;i<2;i++) if(maxm[i]-m[i]<2) room++;//+1 if there is not room for a homozygous kid.			
	if(homKid.size()>0 && room==4 && aa==0 && bb==0) go=0;//don't have room for one, don't add the node.
	
	if(j==K-2 && homKid.size()==1 && aa==0 && bb==0){//If there are three alleles to be added at the last stage, it won't work.
		for(i=0;i< (int) m.size();i++) if(homKid[0]!=i && minm[i]-m[i]>0) go=0;			
	}	

	for(i=0;i< (int) m.size();i++){ //The number of alleles needed exceeds the number possible in the remaining stages.
		if(j==K-2 && (minm[i]-m[i]>max[i])) go=0;
	}

	vint knot;
	if(j==K-2){
		for(i=0;i< (int) m.size();i++) {
			int Z=maxm[i]-m[i];
			if(Z!=0) knot.push_back(i);
		}
		if(knot.size()==1 && homKid.size()==0) go=0;//The only alleles that are possible create a genotype that is knot.
		else if(knot.size()==2 && genotypes[knot[0]][knot[1]]==0) go=0;
	}
	return go;
}

void TypeG(int obsgenos[][2],int genotypes[][4],vint folks,vint kids,vint homKid)
{//This function creates a matrix of the possible genotypes for the offspring.
	int type;

	//CHECK
	
	if(folks.size() == 2){
		for(int iall = 0; iall < 2; iall++){			
			for(int jall = 0; jall < 2; jall++){ //matrix of possible genotypes, with the allele assigned across rows and columns,
				type = 0;				//a 1 in any cell, indicates a genotype consisting of the corresponding row and col alleles.
				int gen1, gen2;
				gen1 = obsgenos[folks[0]][iall]*  obsgenos[folks[1]][jall];
				gen2 = obsgenos[folks[1]][iall] * obsgenos[folks[0]][jall];
				if(gen1 + gen2 > 1) type = 1; 
				else type = gen1 + gen2;
				genotypes[iall][jall] = type;
	}	}	}	
	else {
		for(int ikid = 0; ikid < (int) kids.size(); ikid++){ //Any observed genotypes among the children admissable
			for(int jall = 0; jall < 2; jall++){
				for(int iall = 0; iall < 2; iall++){
					type = 0;
					if(obsgenos[kids[ikid]][iall] == 1 && obsgenos[kids[ikid]][jall] == 1 && iall != jall ) type = 1;
					else if(obsgenos[kids[ikid]][jall] == 1 && obsgenos[kids[ikid]][iall]==1 && iall != jall) type = 1;
					else if(obsgenos[kids[ikid]][iall] == 2 && iall == jall) type = 1;
					if(type==1){
						genotypes[iall][jall] = type;
						genotypes[jall][iall] = type;
		}	}	}	}		
		
		if(folks.size() == 1){//When one parent is known - possible genotypes are observed + any alleles 
			for(int jall = 0; jall < 2; jall++){//not in parent with alleles of parent. 
				if(obsgenos[folks[0]][jall] == 0){ //If j not in parent
					for(int iall = 0; iall < 2; iall++){
						if(obsgenos[folks[0]][iall] == 1){//pair with i in parent
							genotypes[iall][jall] = 1;
							genotypes[jall][iall] = 1;
		}	}	}	}	}			
		for(int iall = 0 ; iall < (int) homKid.size(); iall++){//If a child is homozygous aa, 			
			for(int jall = 0; jall <  2; jall++){//then a pairs with every other observed allele and
				if(jall != homKid[iall]) {
					genotypes[homKid[iall]][jall] = 1;
					genotypes[jall][homKid[iall]] = 1;
					int h=homKid[iall];
				}
				for(int kall = 0; kall < 2; kall++){//every other allele can pair with every other.
					if(jall != homKid[iall] && kall != homKid[iall] && jall != kall) genotypes[jall][kall] = 1;
		}	}	}	
	}
}

void minmaxA(int obsgenos[][2],vint &Amin,vint &Amax,vint folks,vint kids,int genotypes[][4],vint &homKid)
//Determine the min and max #s of each allele that a child can have
{
	void TypeG(int obsgenos[][2],int genotypes[][4],vint folks,vint kids,vint homKid);//Find all possible genotypes
	int m,M,i,j,k,ok,x;

	for(k = 0;k < 2; k++){	//this is counting the number of each allele among the children.
		for(i = 0; i< (int) kids.size(); i++){
			j = kids[i];
			if(obsgenos[j][k] == 2){//make sure this is not already in there. We want distinct homozygotes.
				ok=1;
				for(x = 0; x < (int) homKid.size(); x++) if(homKid[x] == k) ok = 0;
				if(ok == 1) homKid.push_back(k);
			}
	}	}	

	TypeG(obsgenos,genotypes,folks,kids,homKid);
	//Since Type works, I might as well use it to get mins and maxs, then one procedure will work for any case.
	for(k = 0; k < 4; k++){
		m = 1, M = 0;	
		for(i = 0; i < 4; i++){
			for(j = 0; j < 4; j++){
				if(genotypes[i][j] == 1 && i != k && j != k) m = 0;
				if(genotypes[i][j] == 1 && i == k && j == k) M = 2;
				else if(genotypes[i][j] == 1 && (i == k || j == k) && M == 0) M = 1;				
		}	}		
		Amin.push_back(m);
		Amax.push_back(M);
		int d=Amax[k] - Amin[k];
	}
	
	while(Amin.size() < 4){
		Amin.push_back(0);
		Amax.push_back(0);
	}
}

void minmaxm(vint Amin,vint Amax,vint &minm,vint &maxm,int obsgenos[][2],vint kids,vint folks,vint aff,int nall,vint homKid,int genotypes[][4],int ngens)
//determines the min and max #s of each allele for a family, also the max possible number of heterozygotes
{
	int i,n = (int) kids.size(),k,m,j,mina = Amin[0], maxa = Amax[0],homPar = 0,ever = -1;
	vint diff,mAll,pall;
		
	for(i = 0; i < (int) Amin.size();i++) diff.push_back(Amax[i] - Amin[i]);

	for(k = 0; k < nall; k++){	//this is counting the number of each allele among the children.
		m = 0;
		for(i = 0; i < n; i++){
			j = kids[i];
			m += obsgenos[j][k];			
		}	
		mAll.push_back(m);		
	}
	while(mAll.size() < 4) mAll.push_back(0);

	for(k = 0; k < nall; k++){		//I need to know the parental alleles
		m = 0;
		for(i = 0; i < (int) folks.size(); i++){
			j = folks[i];
			m += obsgenos[j][k];
		}
		pall.push_back(m);
		if(m==2) homPar = 1;
	}
	while(pall.size() < 4) pall.push_back(0);

	for(i = 0; i < (int) Amin.size(); i++){
		if(folks.size() == 2){
			minm.push_back(n * Amin[i]);	//# of kids times min # of alleles = min marginal
			maxm.push_back(n * Amax[i]);	//# of kids times max# of alleles=maximum marginal	
		}
		else if(nall == 2 && diff[0] == 1 && homPar == 0){ //when the kids are aa and ab, simply permute genotypes
				minm.push_back(mAll[i]);//Aack! what about parent=aa case?
				maxm.push_back(mAll[i]);
		}
		else if(folks.size() == 1 && homPar == 0 && nall > 2){//One heterozygous parent - the difficult case
			if(genotypes[pall[0]][pall[1]] == 1){//If the parent's genotype is possible among the kids
				if(homKid.size() == 1){
					if(i == homKid[0]) minm.push_back(2);	//case parent- ab, kids in {aa,ac} or {aa,bc} 
					else minm.push_back((n - 1) * Amin[i] + Amax[i] - pall[i]);//or {aa,ab,ac} or {aa,ab,bc} or {aa,ac,bc}
					if(pall[i] == 1 && i != homKid[0]) maxm.push_back(n-1);
					else maxm.push_back((n - 1) * Amax[i] + Amin[i] + pall[i]);
				}
				else{
					minm.push_back((n - 1) * Amin[i] + Amax[i]);
					maxm.push_back((n - 1) * Amax[i] + Amin[i] + pall[i]);
				}
			}
			else{
				minm.push_back((n - 1) * Amin[i] + Amax[i] - pall[i]);	//case parent- ab, kids in {ac,bd} or {ac,bc,bd,ad}
				maxm.push_back((n - 1) * Amax[i] + Amin[i] + pall[i]);	//or {ac,ad} or {ac,bc,bd} or {ac} or {ac,bc}
			}
		}
		else{
			minm.push_back((n - 1) * Amin[i] + Amax[i]);
			maxm.push_back((n - 1) * Amax[i] + Amin[i]);
		}
	}

	while(maxm.size() < 4){
		minm.push_back(0);
		maxm.push_back(0);
	}
}

double pvalue(double exval,double var,Node *tNode,REC *tRec,double ObsS)
{
	REC *currec = tRec;
	double unp = 0, unp1 = 0, p;
	double prob = tNode[1].tp;
	int first = 1;

	double normS = pow(ObsS - exval, 2) / var;
	
	while(currec!=NULL)
	{	
		double normT = pow(currec->pastr - exval, 2) / var;		
		//Deal with rounding error.
				
		if(normT >= normS-0.0000000001)
		{
			if(first == 1)
			{ //Do this to avoid adding an extra 1 to the unnormalized probability.
				first = 0;
				unp = currec->pastp;
			}
			else unp = addlog(unp,currec->pastp);			
		}		
		currec = currec->nextrec;
	}
	p = exp(unp - prob);	
	if(p > 1) p = 1;
	return(p);
}

void moment(REC *newrec, Node *tNode, double &ev, double &ev2)
{
	double tp = (double) tNode[1].tp;
	double unp = 0, P = -1;
	REC *currec;

	currec = newrec;
	while(currec != NULL)
	{
		ev += (currec->pastr) * (exp(currec->pastp - tp));
		ev2 += pow((currec->pastr),2) * (exp(currec->pastp - tp));
		currec = currec->nextrec;
	}
	return;
}

void forwardX(int nstage,int nnodes,Node *nodes,int minA[],int maxA[],int minm[],int maxm[],vint stage,vint cell,
			  vint stpos,vint endpos,int genma[2],int ma,int pa,int homdot,vint sons,vint dots,vint aff,int mod)
{
	int numrec;
	double npr,p,ipl,r,ev = nodes[1].ev;
	int rj, ndots = (int) dots.size();

	vint sex;
	for(int d = 0; d < ndots;d++ ) sex.push_back(2);
	for(int s = 0; s < (int) sons.size();s++ ) sex.push_back(1);
	sex.push_back(2);

	vint affdotson;
	for(int d = 0; d < ndots;d++ ) affdotson.push_back(aff[dots[d]]);
	for(int s = 0; s < (int) sons.size();s++ ) affdotson.push_back(aff[sons[s]]);
	affdotson.push_back(0);
		
	REC *newrec,*currec,*nxt,*curr; //create pointers for traversing the network.

	numrec = 1;
	
	for (int istage = 0; istage <= nstage - 1; istage++ )
	{ //Cycle through K stages of the network.
		for (int pos = stpos[istage]; pos <= endpos[istage]; pos++ )
		{	//Cycle through all nodes at stage istage.
			rj = cell[pos];
			if (nodes[pos + 1].rec  ==  NULL) //If no contributing path emanates from this node, move on.
				continue;			//causes loop to stop current iteration and begin next one 

//VISIT ALL SUCCESSOR NODES
			int lowlim, uplim, low, up;
			int tmax = cell[stpos[istage + 1]];
			int tmin = cell[stpos[istage + 1]];
			for(int c = stpos[istage + 1]; c <= endpos[istage + 1]; c++ )
			{
				if(cell[c] > tmax) tmax = cell[c];
				if(cell[c] < tmin) tmin = cell[c];
			}
			if(sex[istage] == 2) 
			{
				low = IMAX(rj + minA[0], tmin);
				if(low > maxm[0]) low = maxm[0];
			}
			if(sex[istage] == 1) 
			{
				low = IMAX(rj + minA[1], tmin);
				if(low > maxm[2]) low = maxm[2];
			}
			lowlim = low;	//Minimum value of a successor
			if(sex[istage] == 2) uplim = IMIN(rj + maxA[0],tmax);	//Maximum value of a successor
			if(sex[istage] == 1) uplim = IMIN(rj + maxA[1],tmax);	//Maximum value of a successor
			
			currec = nodes[pos + 1].rec;

			while (currec  !=  NULL) 
			{
				for(int inode = stpos[istage + 1]; inode <= endpos[istage + 1]; inode++ )
				{
//Cycle through all nodes at the next stage, check to see which of these are successor nodes (goOn == 1).
					int goOn = 1;
					
					low = lowlim;
					up = uplim;
					if(up < low)
					{
						int temp = up;
						up = low;
						low = temp;
					}
					if(low <= cell[inode] && cell[inode] <= up) ;
					else goOn = 0;
					int x = cell[inode] - rj;					
		
					if(sex[istage] == 2 && (x < minA[0] || x > maxA[0])) goOn = 0; //Don't go on if x is below its minimum
					if(sex[istage] == 1 && (x < minA[1] || x > maxA[1])) goOn = 0; //value or above its maximum.
					
					if(istage < ndots && x > 2) goOn = 0; //If this is adding more than 2 alleles for a daughter, don't go on.
					else if(istage >= ndots && x > 1) goOn = 0;	//If this is adding more than 1 allele for a son, don't go on.
																									
//This step above checks to see which nodes are successor nodes, if we are at the stage before the terminal node,
//all nodes have the same single successor whether it meets these criteria or not, so in that case goOn == 1 regardless.
					if(istage == nstage-1) goOn = 1; 										
					if(goOn == 1)
					{
						int y = x;
						if(sex[istage] == 2)
						{
							if(mod == 2 && y != 0) y = 1;
							if(mod == 3){
								if(y == 2) y = 1;
								else y = 0;
							}
						}
						ipl = y * affdotson[istage];					
																	
						r = currec->pastr + ipl;	//calculate rank length
						p = 0.0; //All outcomes are equally likely.
						if(istage == nstage - 1) p = 0.0, r = currec->pastr;
							
						if (currec->pastp<0.0000001) npr = p;	//calculate prob length isn't this redundant?
						else npr = currec->pastp + p;							
						newrec = crerec(r,npr);
						numrec++ ;
						if (nodes[inode + 1].rec  ==  NULL)		//If the next record is null, make it the new one
							nodes[inode + 1].rec = newrec;
						else if (nodes[inode + 1].rec->pastr > newrec->pastr) //Else if the new r is less than the old one
						{
							newrec->nextrec  =  nodes[inode + 1].rec;		//the new record points to the old
							nodes[inode + 1].rec  =  newrec;
						}
						else 
						{
							curr = nodes[inode + 1].rec;		//otherwise, 
							nxt = curr->nextrec;
							while (nxt  !=  NULL)			//move through until pointing to null
							{
								if (r  ==  curr->pastr || (nxt  !=  NULL && (r < nxt->pastr)))
										break;
								curr = nxt;
								nxt = curr->nextrec;
							}
							if (r  ==  curr->pastr)//if the record is already there, augment the prob and remove rec
							{		
								curr->pastp = addlog(curr->pastp,newrec->pastp);
								free(newrec);
								numrec--;
							}
							else 
							{
								newrec->nextrec = nxt;	//otherwise, add the record
								curr->nextrec = newrec;
							}
						}					
					}
				}										
				currec = currec->nextrec;
			}
		}
	}	
}


void backwardX(int nstages,int nnodes,Node *nodes,int minA[],int maxA[],vint stage,vint cell,vint stpos,vint endpos,int genma[2],
			  int ma,int pa,int homdot,vint sons,vint dots,vint aff,int mod)
{//I will refer to the extra node for each network as the end node, the nodes one stage before are the terminal nodes.
	//Since there is no trimming, backward's functions are to compute TP and moments, and to identify uniformative families.
	
	double splj = 0, lplj = 0;//Shortest and longest paths for the current family.
	double totprob = nodes[nnodes].tp, ev = nodes[nnodes].ev, var = nodes[nnodes].var, exx = 0.0;	
	
	void pathX(Node *nodes,int nnodes,int pos,int istage,int nstages,vint stage,vint cell,vint stpos,vint endpos,
		int minA[],int maxA[],int genma[],int ma,int pa,int homdot,vint sons,vint dots,vint aff,
		int mod,double *splj,double *lplj,double *eval,double *var,double *totprob);
	
	for(int istage = nstages - 1; istage >= 0; istage--)
	{//begin at the last stage and process through to the first
		int npos = stpos[istage];
		if(istage == nstages - 1)
		{ //When we are at a stage preceding an end node, all rank and prob lengths will be 0 and 1 resp.
			for(int inode = stpos[istage]; inode <= endpos[istage]; inode++)
			{ //This is a dummy node, so these values are unchanged from previous node	
				nodes[npos+1].setNode(0,0,ev,exx,totprob,NULL);
				npos++;				
			}			
		}		
		else
		{ //If we're not at the terminal nodes for a family, find the shortest and longest paths and the total prob for the node
			for(int inode = stpos[istage]; inode <= endpos[istage]; inode++) 
			{//Find spl, lpl, and totprob for the node
				pathX(nodes,nnodes,inode,istage,nstages,stage,cell,stpos,endpos,minA,maxA,genma,ma,pa,homdot,sons,dots,aff,mod,
					&splj,&lplj,&ev,&exx,&totprob);
				nodes[npos+1].setNode(splj,lplj,ev,exx,totprob,NULL);
				npos++;
			}
		}					
	}
return;
}

void pathX(Node *nodes,int nnodes,int pos,int istage,int nstages,vint stage,vint cell,vint stpos,vint endpos,
		int minA[],int maxA[],int genma[],int ma,int pa,int homdot,vint sons,vint dots,vint aff,
		int mod,double *splj,double *lplj,double *eval,double *var,double *totprob)
{
	double ispj,ispj2,ilpj,ilpj2;
	double pr,prob,iev,iev2,iexx,iexx2;
	int ndots = (int) dots.size(), nsons = (int) sons.size();

	vint sex;
	for(int d = 0; d < ndots; d++) sex.push_back(2);
	for(int s = 0; s < nsons; s++) sex.push_back(1);
	sex.push_back(2); //A dummy for the final stage.

	vint affdotson; //Affected status of daughters then sons.
	for(int d = 0; d < ndots; d++) affdotson.push_back(aff[dots[d]]);
	for(int s = 0; s < nsons; s++) affdotson.push_back(aff[sons[s]]);
	affdotson.push_back(0); //A dummy for the final stage.

	int rj = cell[pos];	
	int tmax = cell[stpos[istage + 1]];
	int tmin = cell[stpos[istage + 1]];
	for(int c = stpos[istage + 1]; c <= endpos[istage + 1]; c++)
	{
		if(cell[c] > tmax) tmax = cell[c];
		if(cell[c] < tmin) tmin = cell[c];
	}

	int lowlim, uplim;
	if(sex[istage] == 2)
	{
		lowlim = IMAX(rj + minA[0], tmin);	//Minimum value of a successor
		uplim = IMIN(rj + maxA[0], tmax);	//Maximum value of a successor	
	}
	else if(sex[istage] == 1 )
	{
		lowlim = IMAX(rj + minA[1], tmin);	//Minimum value of a successor
		uplim = IMIN(rj + maxA[1], tmax);	//Maximum value of a successor	
	}
	int low = lowlim,up = uplim;
	
	int num = 0;
	double tp = 0, ev = 0, exsqi = 0.0;	
	
	for(int jnode = stpos[istage + 1]; jnode <= endpos[istage + 1]; jnode++)
	{//cycle through all nodes at this stage
		int go = 1;
		if(low <= cell[jnode] && cell[jnode] <= up) ;
		else go = 0;

		int x = cell[jnode] - rj;
					
		if(sex[istage] == 2 && (x < minA[0] || x > maxA[0])) go = 0; //Make sure the x value is 'legal'.
		if(sex[istage] == 1 && (x < minA[1] || x > maxA[1])) go = 0;
		if(istage < ndots && x > 2) go = 0; //Can't transmit more than 2 alleles to a daughter.
		else if(istage >= ndots && x > 1) go = 0; //Can't transmit more than 1 allele to a son.
		if(go == 0) continue;
		
		if(go == 1){		
			num++;	
			int y = x;
			if(sex[istage] == 2)
			{				
				if(mod == 2) if(x != 0) y = 1; //dominant case
				if(mod == 3){ //recessive case 
					if(x == 2) y = 1;
					else y = 0; 
				}
			}
			
			int ipl = y * affdotson[istage]; //affdotson contains the affected status of all daughter, followed by that of all sons.			
			int ipl2 = y * y * affdotson[istage];
			ispj = nodes[jnode+1].spj + ipl; //Add the current path length to the shortest path for this node.
			ilpj = nodes[jnode+1].lpj + ipl; //Add the current path length to the longest path for this node.

			pr = 0; //All outcomes are equally probable.
			prob = pr + nodes[jnode+1].tp;
			iev = log(nodes[jnode+1].ev + ipl) + (prob);
			double temp = nodes[jnode+1].var + pow(nodes[jnode+1].ev + ipl, 2);
			iexx = log(temp) + (prob);
					
			if(num > 1){ //when there is more than one successor node, compare path lengths to find longest and shortest.
				if (ispj2 < ispj) ispj = ispj2;
				if (ilpj2 > ilpj) ilpj = ilpj2;
				iev = addlog(iev,iev2);
				iexx = addlog(iexx, iexx2);
				tp = addlog(tp, prob);
			}
			else tp = prob;
			

			ev = exp(iev - tp);
			exsqi = exp(iexx - tp);
			
			ispj2 = ispj;
			ilpj2 = ilpj;
			iev2 = iev;
			iexx2 = iexx;
		}		
	}
	*splj = ispj;
	*lplj = ilpj;	
	*totprob = tp;
	*eval = ev;
	*var = exsqi-ev*ev;
	return;
}


const int NR_END=1;

Node *NDvector(long nl, long nh)
/* allocate an NODE vector with subscript range v[nl..nh] */
{
	Node *v;

	v=(Node *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(Node)));
	//if (!v) nrerror("allocation failure in NDvector()");
	return v-nl+NR_END;
}

#define FREE_ARG char*

void free_NDvector(Node *v, long nl,long nh)
{
	free((FREE_ARG) (v+nl-NR_END));
}

REC * crerec(double r,double pr)	//This function creates a record and stores values in p and r
{		
	REC *record;

	record=(REC *)malloc(sizeof(REC));
	record->pastr=r;
	record->pastp=pr;
	record->nextrec=NULL;
	
	return(record);
}

void freerec(Rec *rec)
{
	void freerec(Rec *rec);
	if(rec->nextrec != NULL) freerec(rec->nextrec);
	free(rec);
	return;
}


void Node::setNode(double spathj,double lpathj,double eval,double variance,double tprob,REC *r)
{//Monte Carlo uses this same function, I've just not assigned spathj and lpathj.
	spj=spathj;
	lpj=lpathj;
	ev=eval;
	var=variance;
	tp=tprob;
	rec=r;
}

void buildX(int obsgenos[][2],vint &stage,vint &cell,int minA[],int maxA[],int minm[],int maxm[],int homdot,int ma,int pa,vint sons,vint dots)
{	
	//int OK(int rj,int aa,int bb,int homdot,int istage,int nkids,int ma,int pa,int ndots);
	int minAll,maxAll;
	
	int ndots = (int) dots.size(), nsons = (int) sons.size();
	int nkids = ndots + nsons;
	vint sex;
	for(unsigned int idot = 0; idot < dots.size(); idot++) sex.push_back(2); //This is used to make it easy to determine when building for
	for(unsigned int ison = 0; ison < sons.size(); ison++) sex.push_back(1); //males and when for females.

	int genma[2] = {0,0};
	int genpa = 0;
	mapa(ma,pa,genma,genpa,obsgenos); //Find parental genotypes.

	int istage;
	for(istage = 0; istage <= nkids; istage++){			//Add all the nodes to my list. istage is the stage
		for(unsigned int inode = 0; inode < stage.size(); inode++){
			if(stage[inode] == (istage-1)){					//succ(istage,aj,bj,abj)={(istage+1,w,x,y,z):mina<=w<=maxa}
				int rj = cell[inode];						//Succ(istage,r1)={(istage+1, r1,istage+1,r2,istage+2,r3,istage+3): (w, y, z)  genotypes,
				if(sex[istage-1]==2){		//Girls
					minAll = IMAX(rj + minA[0], minm[0] - (ndots - (istage)) * maxA[0]);						
					maxAll = IMIN(maxm[0] - (ndots - istage) * minA[0], rj + maxA[0]);						
				}
				else if(sex[istage-1] == 1){//Boys
					//The minimum cell value is the maximum of the previous cell value plus the minimum addition and the minimum total cell
					//value (by the end) minus the maximum number of alleles that can be added. minm[2] is total.
					minAll = IMAX(rj + minA[1], minm[2] - (nkids - (istage)) * maxA[1]);
					
					//The maximum cell value is the minimum of the previous cell value plus the maximum addition and the maximum total cell
					//value (by the end) minus the minimum number of alleles that can be added.
					maxAll = IMIN((maxm[2]) - (nkids - istage) * minA[1], rj +  maxA[1]);
				}								
				
				for(int w = minAll; w <= maxAll; w++){ //Move through all possible cell values.
					int x = w - rj;
					
					//Look through the vector minus the most recent node to avoid duplicate nodes.
					int go = 1;
					for(unsigned int k = 0; k < stage.size(); k++){	
						if(stage[k] == istage && cell[k] == w) go = 0;
					}
					if(go == 1) {//If go = 1, this node can be added.
						stage.push_back(istage);
						cell.push_back(w);																		
	}	}	}	}	}	
						
	stage.push_back(istage);
	int last = (int) cell.size();
	cell.push_back(cell[last-1]);
	return;
}

double statistic(int obsgenos[][2],vint aff, vint kids, int mod, vint sex,int xlink)
{
	double S = 0; //Test statistic.
	for(unsigned int ikids = 0; ikids < kids.size(); ikids++){
		int k = kids[ikids];
		//obsgenos has 2 for male genotypes since that was read from the file.  If the son has the genotype, add 1*aff.
		int s = sex[k];
		if(xlink == 1)
		{
			if(sex[k] == 1){	if(obsgenos[k][0] == 2) S += aff[k]; }//Male contribution to S is the same regardless of the inheritance model.
			else if(sex[k] == 2) //Female contribution to S depends on inheritance model.
			{
				if(mod == 1) S += (double) (obsgenos[k][0] * aff[k]); //Additive case.
				else if(mod == 2 && obsgenos[k][0] == 1 || obsgenos[k][0] == 2) S += (double) aff[k]; //Dominant case - add affected status times 1.
				else if(mod == 3 && obsgenos[k][0] == 2) S += (double) aff[k];
			}
		}
		else if(xlink == 0)
		{
			if(mod == 1) S += (double) (obsgenos[k][0] * aff[k]); //Additive case.
			else if(mod == 2 && obsgenos[k][0] == 1 || obsgenos[k][0] == 2) S += (double) aff[k]; //Dominant case - add affected status times 1.
			else if(mod == 3 && obsgenos[k][0] == 2) S += (double) aff[k];			
		}
	}
	return(S);
}

int minmaxX(int obsgenos[][2],int minA[],int maxA[],int pa,int ma,vint sons,vint dots,int genson[],int gendot[][2],int &homdot,int minm[3],int maxm[3])
//Determine the min and max #s of each allele that a child can have
{
	int ndots = (int) dots.size(), nsons = (int) sons.size();	 
	for(int r = 0; r < 2; r++) minA[r] = maxA[r] = minm[r] = maxm[r] = 0;
	minm[2] = minm[2] = 0;
	maxm[2] = maxm[2] = 0;

	int ok = checkgenos(obsgenos,sons,dots,pa,ma); //Check for incompatible genotypes.	
	if(ok == 0) return(ok);

	TypeX(obsgenos,genson,gendot,ma,pa,sons,dots,homdot);
	//Use results from Type to determine maxima and minima.
	int genma[2] = {-1,-1}, genpa = -1; //Hold parental genotypes.
	mapa(ma,pa,genma,genpa,obsgenos); //Find parental genotypes.

	int mindot = 0, maxdot = 0;
	if(ndots > 0) 
	{
		mindot = 2, maxdot = 0; //Initial minimum and maximum of allele A for one daughter.
		if(gendot[0][0] == 1) maxdot = 2; //If there's a homozygous AA daughter, the maximum for allele A is 2.
		if(gendot[1][0] == 1){
			mindot  = 1; //If there's a heterozygous daughter, the minimum for A is no more than 1.
			if(maxdot == 0) maxdot = 1; //If there's a heterozygous daughter and the maximum has not been changed, the maximum for A is 1.
		}
		if(gendot[1][1] == 1) mindot = 0; //If there's a homozygous BB daughter, the minimum for allele A is 0.
	}
	
	int minson = 1, maxson = 0; //Initial minimum and maximum of alleles for one son.
	if(nsons == 0) minson = 0; //No sons.
	else{ //m2s and M2s are the minimum and maximum of alleles for a son.  None can be more than 1.
		if(genson[0] == 1) maxson = 1 ;
		if(genson[1] == 1) minson = 0;
	}
		
	minA[0] = mindot;  //Row 0 is dot, row 1 is son
	minA[1] = minson; 
	maxA[0] = maxdot;
	maxA[1] = maxson; 

	minm[0] = mindot * ndots; 
	minm[1] = minson * nsons; 
	maxm[0] = maxdot * ndots; 
	maxm[1] = maxson * nsons; 
	
	//Special cases when parental data are missing:
	//1. Father missing, AA dot => Must include AA dot.
	if(pa == -1 &&  ma != -1)
	{
		if(homdot == 0) minm[0] = IMAX(minm[0], ndots + 1); //AA dot, AA must be included.
		else if(homdot == 1) maxm[0] = IMIN(maxm[0], ndots - 1); //BB dot, BB must be included.
	}
	
	//2. Both parents missing, 
	if(ma == -1 && pa == -1)
	{
		if(homdot == -1) //No homdot => must include all sons genos.
		{
			if(genson[1] == 1 && genson[0] == 1) 
			{
				minm[1] = 1;
				maxm[1] = nsons - 1;
			}
		}
		if(homdot == 0) minm[0] = IMAX(minm[0], ndots + 1); //AA dot, AA must be included.
		if(homdot == 1)	maxm[0] = IMIN(maxm[0], ndots - 1); //BB dot, BB must be included.		
	}
	/*DEAL WITH OVERALL MINM AND MAXM (MINM[2] AND MAXM[2]).*/
	//The minimum and maximum for all children in the family.  These are found by taking the values for the dots plus the sons values.
	minm[2] = minm[0] + minm[1]; 
	maxm[2] = maxm[0] + maxm[1]; 

	//Both parents missing, no homozygous daughter.
	if(ma == -1 && pa == -1) 
	{ //Require at least 1 B.	
		if(homdot == 0) maxm[2] = IMIN(maxm[2], 2 * ndots + nsons - 1);
		else if(homdot == 1) minm[2] = IMAX(minm[2], 1);
	}		

	//Mother missing, A father => must include one of AA or A if either is observed, some B.
	if(ma == -1 && pa != -1)  //genpa will be either 0 or 1 or missing.
	{  
		if(genpa == 0 && (homdot == 0 || genson[0] == 1)) //0 is the allele that is being analyzed.
		{
			minm[2] = IMAX(ndots + 1, minm[0] + minm[1]);		
			maxm[2] = IMIN(maxm[2], maxm[0] + maxm[1] - 1);	
		}
		if(genpa == 1 && (homdot == 1 || genson[1] == 1))
		{
			minm[2] = IMAX(1, minm[0] + minm[1]);		
			maxm[2] = IMIN(maxm[0] + maxm[1], ndots + nsons - 1);	
		}		
	}
	//If there are daugthers only minm[0]=minm[2];
	if(nsons == 0)
	{
		minm[0] = IMAX(minm[0],minm[2]);
		maxm[0] = IMIN(maxm[0],maxm[2]);
	}

	/*cout <<"\nMinA[0]: " <<minA[0] <<", MinA[1]: " <<minA[1];
	cout <<"\nMaxA[0]: " <<maxA[0] <<", MaxA[1]: " <<maxA[1];
	cout <<"\nMinm[0]: " <<minm[0] <<", Minm[1]: " <<minm[1];
	cout <<"\nMaxm[0]: " <<maxm[0] <<", Maxm[1]: " <<maxm[1];
	cout <<"\nMinm[2]: " <<minm[2] <<", Maxm[2]: " <<maxm[2];*/

	return(ok);
}

void TypeX(int obsgenos[][2],int genson[],int gendot[][2],int ma,int pa,vint sons,vint dots,int &homdot)
{//This function creates a matrix of the possible genotypes for the offspring.
	int genma[2] = {-1,-1}, genpa = -1; //Hold parental genotypes.

	genson[0] = genson[1] = 0;
	gendot[0][0] = gendot[0][1] = gendot[1][0] = gendot[1][1] = 0;

	mapa(ma,pa,genma,genpa,obsgenos); //Find parental genotypes.

	/*IDENTIFY GENOTYPES FROM PARENTS*/
	if(ma != -1 && pa != -1)//No missing parental genotypes.
	{ //If both parents are observed, the daughter can have either mother's allele, must have father's allele.
		gendot[genpa][genma[0]] = gendot[genma[0]][genpa] = 1;
		gendot[genpa][genma[1]] = gendot[genma[1]][genpa] = 1;
		//Sons depend on mother only.
		genson[genma[0]] = 1;
		genson[genma[1]] = 1;
	}
	else 
	{
	/*FIND ALL OBSERVED GENOTYPES*/
		for(unsigned int idot = 0; idot < dots.size(); idot++)
		{ //All genotypes observed among daughters:
			if(obsgenos[dots[idot]][0] == 2) 
			{//homdot holds the index (in famalls) of the allele for which a daughter is homozygous.
				gendot[0][0] = 1;
				homdot = 0; //Since the father has only one allele, there can be at most one hom genotype among the dots.
			}
			else if(obsgenos[dots[idot]][1] == 2)
			{
				gendot[1][1] = 1;
				homdot = 1;
			}
			else if(obsgenos[dots[idot]][0] == 1 && obsgenos[dots[idot]][1] == 1) gendot[0][1] = gendot[1][0] = 1;
		}			
		for(unsigned int ison = 0; ison < sons.size(); ison++)
		{ //All genotypes observed among sons:		
			if(obsgenos[sons[ison]][0] == 2) genson[0] = 1;
			else if(obsgenos[sons[ison]][1] == 2) genson[1] = 1;
		}
	 /*FIND OTHER POSSIBLE GENOTYPES*/
		if(ma != -1 && pa == -1) //Mother not missing, father missing.
		{ //Sons depend on mother only
			genson[genma[0]] = 1;
			genson[genma[1]] = 1;			
		}
		if(ma == -1 && pa != -1) //Father not missing, mother missing.
		{//A daughter can have father's allele with either of son's alleles.
			for(unsigned int ison = 0; ison < sons.size(); ison++)
			{
				if(obsgenos[sons[ison]][0] == 2) gendot[0][genpa] = gendot[genpa][0] = 1;
				if(obsgenos[sons[ison]][1] == 2) gendot[1][genpa] = gendot[genpa][1] = 1;
			}
			//The son can have any allele that the daughter has which was not inherited from the father.
			//I.e. if a daughter is heterozygous, a son can have the allele that the father does not have.
			if(gendot[1][0] == 1) genson[1-genpa] = 1;
		}
		
		//Since there must be two alleles, if there is a homozygous daughter, the genotypes AA, AB, A, and B are possible.  
		//There must be an AA and a B.
		if(homdot != -1)
		{
			genson[0] = genson[1] = 1;
			gendot[1][0] = gendot[0][1] = 1;
		}		
	}	
/*If neither parent is missing, children's genotypes are straightforward.
If the mother is missing, sons can have any observed genos and any for which a dot is homozygous.
						  dots can have observed genos and father's with any sons'.
If the father is missing, sons can have either of mother's.
						  dots can have observed genos and any allele for which a dot is hom paired with any son allele.
If both parents are missing, sons can have observed genos and any for which a dot is homozygous.
							 dots can have observed genos and any allele for which a dot is hom paired with any son all.*/
}

void mapa(int ma,int pa,int genma[],int &genpa,int obsgenos[][2])
{
	if(pa != -1)
	{
		if(obsgenos[pa][0] == 2) genpa = 0; //Identify father's allele.	
		else if(obsgenos[pa][1] == 2) genpa = 1; //Identify father's allele.
		else genpa = -2; //Genotype is ambiguous.
	}
	if(ma != -1)
	{
		if(obsgenos[ma][0] == 2) genma[0] = genma[1] = 0;
		else if(obsgenos[ma][1] == 2) genma[0] = genma[1] = 1;
		else if(obsgenos[ma][0] == 1 || obsgenos[ma][1] == 1)
		{
			genma[0] = 0;
			genma[1] = 1;
		}
	}
}

int checkgenos(int obsgenos[][2],vint sons,vint dots,int pa,int ma)
{//Verify that the genotype is possible.
	int ok = 1;//Indicates whether the genotype is ok.
	int genpa, genma[2];  //A convenient way to hold parental alleles, contain indices of alleles in famalls.
	mapa(ma,pa,genma,genpa,obsgenos); //Find parental genotypes.  

	//1. If the mother is homozygous, all dots have the same genotype as do all sons.
	if(ma != -1 && (obsgenos[ma][0] == 2 || obsgenos[ma][1] == 2)) //If the mother is homozygous.
	{ 
		for(unsigned int idot = 1; idot < dots.size(); idot++)
		{ //Compare daughters 2 thru ndots to daughter 1.
			if(obsgenos[dots[idot]][0] != obsgenos[dots[0]][0]) ok = 0;
			if(obsgenos[dots[idot]][1] != obsgenos[dots[0]][1]) ok = 0;
		}	//If the daughters are not all the same return 0;	
	}

	//2. Daughters must have one allele from the mother.
	if(ma != -1)
	{
		for(unsigned int idot = 1; idot < dots.size(); idot++)
		{ //Obsgenos contains counts.
			int fromma = 0; //Use genma because it holds allele 'names' (indices) rather than counts.
			if(obsgenos[dots[idot]][genma[0]] > 0) fromma++;  //If daughter i has at least one of mom's allele 0, ok.
			else if(obsgenos[dots[idot]][genma[1]] > 0) fromma++; //If daughter i has at least one of mom's allele 1, ok.
			if(fromma == 0) ok = 0;
		}
	}

	//3. If the father is known, all daughters have at least one allele in common.
	if(pa !=- 1){ //Verify that all daughters have one allele from their father.
		if(genpa == -2) ok = 0; //Father's genotype is ambiguous.
		else for(unsigned int idot = 0; idot < dots.size(); idot++) 		
			if(obsgenos[dots[idot]][genpa] == 0) ok = 0;		
	}

	//4. Son's alleles must come from mother.
	if(ma != -1){
		for(unsigned int ison = 0; ison < sons.size(); ison++){
			if(obsgenos[sons[ison]][genma[0]] == 0 && obsgenos[sons[ison]][genma[1]] == 0) ok = 0;
		}//If the son has neither the mother's first allele, nor her second, ok = 0.
	}

	//5. If son has two different alleles, genotype is ambiguous.
	for(unsigned int ison = 0;ison < sons.size(); ison++){
			for(int iall = 0; iall < 2; iall++)
				if(obsgenos[sons[ison]][iall] == 1) ok = 0;
	}
	return(ok);
}

void alleles(int obsgenos[][2],vint index,vint allAlls,long **peddata,int startpos,int curall)
{
	for(unsigned int i = 0; i < index.size(); i++){//Go through the entire family.
		int ind = index[i];
		
		//obsgenos will be counts of curall in column 0 and not-curall in column 1 (A and B), thus >2 alleles can be dealt with.
		int temp = allAlls[curall];
		if(peddata[ind][startpos] == allAlls[curall] && peddata[ind][startpos+1] == allAlls[curall])
		{
			obsgenos[i][0] = 2;
			obsgenos[i][1] = 0;
		}
		else if(peddata[ind][startpos] == allAlls[curall] || peddata[ind][startpos+1] == allAlls[curall])
		{
			obsgenos[i][0] = 1;
			obsgenos[i][1] = 1;
		}
		else
		{
			obsgenos[i][0] = 0;				
			obsgenos[i][1] = 2;
		}
	
	}
}
void alleles(int **alls,vint index,vint uall,long **data,int st) //for linkage == 1, xlink = 0
{
	int k;
	unsigned int i,j;
	for(i=0;i<index.size();i++){
		k=index[i];
		for(j=0;j<uall.size();j++){
				if(data[k][st]==uall[j] && data[k][st+1]==uall[j]) alls[i][j]=2;
				else if(data[k][st]==uall[j] || data[k][st+1]==uall[j]) alls[i][j]=1;
				else alls[i][j]=0;				
		}
	}
}


void nuclear(long** peddata,int npedrows,vint &index,vint &folks,vint &kids,long ped,long dad,long mom,vint &aff,int startpos,vint &sons,vint &dots,int &pa,int &ma,vint &sex)
{	
	pa = ma = -1;  //These will be -1 if the parents are missing, otherwise they will be like folks.
	int famindex = 0;  //Indexes the individuals solely within the current nuclear family.	
	for(int irow = 0; irow < npedrows; irow++){
		//If any of the alleles, or the sex is unknown, the person is uninformative.
		if(peddata[irow][startpos] == 0 && peddata[irow][startpos+1] == 0) continue;
		else if(peddata[irow][startpos] == 0 || peddata[irow][startpos+1] == 0) continue;
		else if(peddata[irow][4] == 0) continue; //Sex is unknown.
		
		int yes = 0;
		if((peddata[irow][1] == dad || peddata[irow][1] == mom) && peddata[irow][0] == ped )
		{//Identify the parents.
			if(peddata[irow][4] == 1) pa = famindex;
			else if(peddata[irow][4] == 2) ma = famindex;
			folks.push_back(famindex); // Holds the indices of the parents.
			index.push_back(irow); // Holds the indices of the nuclear family.
			yes = 1;				//Yes this person is in the family.
			famindex++; //Augment for next person.
		}
		else if(peddata[irow][2]==dad && peddata[irow][3]==mom && peddata[irow][0]==ped )
		{//Identify the children.
			kids.push_back(famindex);
			if(peddata[irow][4] == 2) dots.push_back(famindex);
			else if(peddata[irow][4] == 1) sons.push_back(famindex);
			index.push_back(irow);
			yes = 1;
			famindex++;
		}
		if(yes == 1){
			if(peddata[irow][5] == 0) aff.push_back(0);
			else aff.push_back(peddata[irow][5]-1); //aff will contain 1s and 0s only.
			sex.push_back(peddata[irow][4]);
		}		
	}	
}

void nuclear(long** data,int rows,int cols,vint &index,vint &folks,vint &kids,long ped,int dad,int mom,vint &aff,int st)
{
	int yes;
	int i,k=0;
		
	for(i=0;i<rows;i++){
		if((data[i][st]==0 && data[i][st+1]==0) || (data[i][st]==0 || data[i][st+1]==0)) continue;
		yes=0;
		if((data[i][1]==dad || data[i][1]==mom) && data[i][0]==ped){
			folks.push_back(k);
			index.push_back(i);
			yes=1;
			k++;
		}
		else if(data[i][2]==dad && data[i][3]==mom && data[i][0]==ped){
			kids.push_back(k);
			index.push_back(i);
			yes=1;
			k++;
		}
		if(yes==1){
			if(data[i][5]==0) aff.push_back(0);
			else aff.push_back(data[i][5]-1);
		}		
	}	
}

void pedigrees(long** peddata, int npedrows, int &nped, veclong &pids, veclong &mids, veclong &fids)
{
	int pedid=peddata[0][0]; //The first pedigree is from the first entry.
	int mom, dad;	//Holds current values of mom and dad.
	nped=1;
	
	for(int irow = 0; irow < npedrows; irow++){//Move through peddata until the pedigree id changes, this is sequential
		int ya = 0;
		if(peddata[irow][0] != pedid)
		{
			pedid = peddata[irow][0]; //Change pedid as the pedigree changes and count pedigress.
			for(unsigned int prow = 0; prow < pids.size(); prow++) if(pedid == pids[prow]) ya = 1;
			if(ya == 0) nped++; //Count the number of pedigrees;
		}
		dad = peddata[irow][2];  
		mom = peddata[irow][3];
		int famsize = 0;
		ya = 0;
		
		//Make sure individuals are not counted as families - there must be more than one person with the same parents.
		if(dad == 0 || mom == 0) ya=1; //Don't need to include 0, 0 parents since theses don't distinguish a unique family.
		else
		{
			for(int jrow = 0; jrow < npedrows; jrow++) {
				if((pedid == peddata[jrow][0]) && (mom == peddata[jrow][3] && dad == peddata[jrow][2]) 
					|| mom == peddata[jrow][1] || dad == peddata[jrow][1]) famsize++;
			}
			if(famsize == 1) ya = 1; 
			for(unsigned int jrow = 0; jrow < mids.size(); jrow++) if(mids[jrow] == mom && fids[jrow] == dad && pedid == pids[jrow]) ya = 1;
		}
		
		if(ya == 0){ //Each family should be distinguished by pid, fid, and mid thus pid may contain duplicates.
			fids.push_back(dad);
			mids.push_back(mom);
			pids.push_back(pedid);			
		}		
	}		
	if(pids.size() == 0) cout <<"Failed to open file. " <<endl;  //If there are no mothers, we haven't read in any information.	
}

void countAlleles(long **peddata, vint &famalls, vint index, int startpos)
{	
	for(unsigned int k = 0; k < index.size(); k++){	//count the number of unique alleles
		int i = index[k];
		int allele1 = peddata[i][startpos];		//The first allele possessed by person i.
		int allele2 = peddata[i][startpos+1];	//The second allele possessed by person i.
		int one = 0,two = 0;
		for(unsigned int j = 0; j < famalls.size(); j++) {	//Sort through the vector to avoid repeats.
			if(famalls[j] == allele1) one = 1;	//If this allele is already in the vector famalls, don't add it.
			if(famalls[j] == allele2) two = 1;			
		}
		if(one == 0 && allele1 != 0 && allele1 > 0) famalls.push_back(allele1); //Add allele1 if it is not zero and if it is not already in the vector.
		if(allele1 != allele2 && two == 0 && allele2 > 0) famalls.push_back(allele2); //Add allele2 if it's different from allele1, its not zero, and its not already in the vector.
	}
	int nall = (int) famalls.size();
	
	int tempArray[NumAll]; //Transfer to array to sort.
	for(int i = 0; i < nall; i++) tempArray[i]=famalls[i]; 
	int swap, temp;
	do{
		swap = 0;
		for(int count = 0; count < (nall-1); count++){
			if(tempArray[count] > tempArray[count + 1]){
				temp = tempArray[count];
				tempArray[count] = tempArray[count+  1];
				tempArray[count + 1] = temp;
				swap = 1;
			}
		}
	}while (swap != 0);
	int u = 0;
	famalls.clear(); //Clear vector before replacing sorted elements.
	for(int i=0;i<nall;i++) if(tempArray[i]!=0) famalls.push_back(tempArray[i]);//Put sorted values back into vector.	
}

int options(int &linkage,int &xlink,int &mod,int &marker,int &nmark,char markernames[][buffsize],int &log,char logfile[80],char pedfile[80],int &curall,vint &allAlls,long **peddata,int rows,bool open)
{
	int opt = 0;
	char temp;
	while(opt != 8 && opt != 7){
		cout <<"\n\n*MENU*" ;

		cout <<"\n1) Log to file. " ;
		if(log == 0) cout <<" [off]";
		else if(log == 1) cout <<" [on]";

		cout <<"\n2) X-linked trait. ";
		if(xlink == 0) cout <<"[off]";
		else if(xlink == 1) cout <<"[on]";

		cout <<"\n3) Choose null hypothesis. ";
		if(linkage == 0) cout <<"[no linkage]";
		else if(linkage == 1) cout <<"[linkage]";

		cout <<"\n4) Choose inheritance model. "; 	
		if(mod == 1) cout <<" [add]";
		else if(mod == 2) cout <<" [dom]";
		else if(mod == 3) cout <<" [rec]";
		
		cout <<"\n5) Choose marker to test.";	
		if(marker == 0) cout <<" [all]";
		else{
			cout << " [" ;
			int letter = 0;
			while(markernames[marker - 1][letter] != 0) cout <<markernames[marker - 1][letter], letter++;
			cout << "]";
		}
		cout <<"\n6) Choose allele. ";	
		if(curall == 0) cout <<" [all]";
		else cout << " ["  << allAlls[curall - 1] << "]";
				
		cout <<" \n7) Analyze.";
		cout <<" \n8) Quit.\n";
		cin >> temp;
		if(temp == '1') opt = 1;
		else if(temp == '2') opt = 2;
		else if(temp == '3') opt = 3;
		else if(temp == '4') opt = 4;
		else if(temp == '5') opt = 5;
		else if(temp == '6') opt = 6;
		else if(temp == '7') opt = 7;
		else if(temp == '8') opt = 8;
		else 
		{
			cout <<"\nError: You have made an invalid choice.";
			opt = 0;
		}
				
		if(opt == 1)
		{
			cout <<"\nLog to file? (0) no (1) yes ";
			cin >> temp;
			if(temp == '1')
			{
				if(open == false){
					int same = 1;
					while(same == 1){
						cout <<"\nEnter logfile name: ";
						cin >> logfile;	
						for(int i=0;i<80;i++) if(pedfile[i] != logfile[i]) same = 0;
						if(same == 1) cout <<"\nERROR: overwriting input file.\n";
					}
				}
				log = 1;
			}
			else if(temp == '0') log = 0;
			else cout <<"\nError: You have made an invalid choice.";
		}	
		else if(opt == 2)
		{
			cout <<"\nX-linked trait? (0) no (1) yes ";
			cin >> temp;
			if(temp == '1') xlink = 1;
			else if(temp == '0') xlink = 0;
			else cout <<"\nError: You have made an invalid choice.";
		}
		else if(opt == 3)
		{
			cout <<"\nChoose null hypothesis. \n(0) 'no linkage, no association' (1) 'linkage, no association' ";
			cin >> temp;
			if(temp == '1') linkage = 1;
			else if(temp == '0') linkage = 0;
			else cout <<"\nError: You have made an invalid choice.";
		}
		else if(opt == 4) //Choose model of inheritance.
		{
			cout <<"1) Additive." <<endl;
			cout <<"2) Dominant." <<endl;
			cout <<"3) Recessive." <<endl;
			cin >> temp;
			if(temp == '1')
			{
				cout <<"\nThe current inheritance model is additive." <<endl <<endl;
				mod = 1;
			}
			else if(temp == '2')
			{
				cout <<"\nThe current inheritance model is dominant." <<endl <<endl;
				mod = 2;
			}
			else if(temp == '3')
			{
				cout <<"\nThe current inheritance model is recessive." <<endl <<endl;
				mod = 3;
			}
			else cout <<"\nERROR: You have made an invalid choice.\n";
		}

		else if(opt == 5) //Choose marker.
		{
			cout <<"Choose marker number: ";
			cout <<"\n(0) all";
			for(int m = 0; m < nmark; m++){
				cout << "\n(" << m+1 << ") ";
				int letter = 0;
				while(markernames[m][letter] != 0) cout <<markernames[m][letter], letter++;
			}
			cout <<endl;
			int temp1;
			cin >> temp1;
			int ok = 0;
			for(int m = 0; m <= nmark; m++) if(temp1 == m) ok = 1;
			if(ok == 1){
				marker = temp1; //If the marker changes, allAlls must be re-figured.
				vint index;
				allAlls.clear();
				int startpos = 6 + (marker - 1) * 2;
				for(int irow = 0; irow< rows; irow++) index.push_back(irow); 
				countAlleles(peddata,allAlls,index,startpos); //Count and record the alleles in the dataset.
				index.clear();
			}
			else cout <<"\nERROR: You have made an invalid choice.\n";			
		}	
		else if(opt == 6) //Choose allele.
		{
			cout << "Choose allele: " ;
			cout <<"\n(0) all";
			for(unsigned int all = 0; all < allAlls.size(); all ++) cout <<"\n(" << all+1  << ") " << allAlls[all];
			cout << endl;
			cin >> temp;
			if(temp == '0') curall = 0;
			else if(temp == '1') curall = 1;
			else if(temp == '2') curall = 2;
			else if(temp == '3') curall = 3;
			else if(temp == '4') curall = 4;
			else if(temp == '5') curall = 5;
			else if(temp == '6') curall = 6;
			else cout <<"\nERROR: You have made an invalid choice.\n";
		}
	}
	return opt;
}

void logo()
{	
	cout <<"          .........................................." <<endl;
	cout <<"          :                                        :" <<endl;
	cout <<"          :  +++++   +++++  +++++     ++    +++++  :" <<endl;
	cout <<"          :  +       +      +    +   +  +     +    :" <<endl;
	cout <<"          :  ++++    ++++   + + +   + ++ +    +    :" <<endl;
	cout <<"          :  +       +      +    +  +    +    +    :" <<endl;
	cout <<"          :  +       +      +    +  +    +    +    :" <<endl;
	cout <<"          :  +++++   +      +++++   +    +    +    :" <<endl;
	cout <<"          :                                        :" <<endl;
	cout <<"          :                                        :" <<endl;
	cout <<"          :  Kady Schneiter 2007                   :" <<endl;
	cout <<"          .........................................." <<endl <<endl <<endl;
}

int size(int &rows, int &cols, char filename[80], char markers[][buffsize])
{
	bool GetMarker(char* theString,char* marker,int& offSet);
	const int buffs=buffsize;
	char stringone[buffs+1];
	char buffer[buffs+1];
	char marker[buffs+1];
	int offSet=0,nmarker=0;

	fstream infile;

	infile.open(filename, ios::in);	//Open file
	infile.get(buffer,buffs);
	while(GetMarker(buffer,marker,offSet)){
		for(int m=0;m<buffs;m++) markers[nmarker][m]=marker[m];
		nmarker++;//Count the number of markers in the file.
	}
	if(nmarker==0) return 0; //If the file is empty or does not exist, terminate.
		
	//cout <<endl <<buffer << " " <<nmarker <<endl;
	cols=2*nmarker+6;
	rows=0;
	while(!infile.eof())
	{
		infile.getline(stringone,buffs+1);
		rows++;
	}
	infile.close();
	rows--;
	return 1;
}

bool GetMarker(char* theString,char* marker,int& offSet)
//From (Jesse Liberty, "Teach yourself C++", 4th ed.,Sams, 2001)
{
	if(!theString[offSet]) return false;//end of string?
	char *p1,*p2;
	p1=p2=theString+offSet;				//Point to the next marker.

	for(int i=0;i<(int)strlen(p1) && !isalnum(p1[0]);i++) p1++; //Eat leading spaces

	if(!isalnum(p1[0])) return false;	//See if you have a marker
	p2=p1;		//p1 and p2 point to the next marker.

	while(isalnum(p2[0])) p2++;			//march p2 to the end of marker.
	int len=int(p2-p1);		//p1 at beginning of marker, p2 at end, find length of marker.

	//strncpy_s(marker,len,p1,80); //Unix doesn't like this.
	strncpy(marker,p1,len);	//copy the marker into the buffer
	marker[len]='\0';		//Null terminate it.
	for(int j=int(p2-theString);j<(int)strlen(theString) && !isalnum(p2[0]);j++) p2++; //Find beg. of next marker
	offSet=int(p2-theString);
	return true;
}

void Clear(vint &v1,vint &v2,vint &v3,vint &v4,vint &v5)
{
	v1.clear();
	v2.clear();
	v3.clear();
	v4.clear();
	v5.clear();
}

double addlog(double num1,double num2)	//Add logs to compute cumulative probabilities
{
	double total,t1,t2,tmax;

	tmax=DMAX(num1,num2);
	t1=DMAX(num1-tmax,-80.0);
	t2=DMAX(num2-tmax,-80.0);
	total=tmax+log(exp(t1)+exp(t2));
	return(total);
}

vecd faclog(int sampsz)	//Computes logs of factorials for probability calculations
{
	double num;
	vecd fact;
	fact.push_back(0.0);
	for (int i=1;i<=sampsz;i++){
		num=fact[i-1]+log((double)i);
		fact.push_back(num);		
	}
	return fact;
}
double prbar0(int numsucc, vecd fact,int diff)	//Calculate total probability
{
	double logprob;

	if (diff==numsucc || numsucc==0)
		logprob=0.0;
	else
		logprob=fact[diff]-fact[numsucc]-fact[diff-numsucc];
	return logprob;
}

void type2(int **alls,vint uall,int genotypes[][4],vint folks,vint kids,vint homKid,vint kidsalls,short &Nobs)
{//This function creates a matrix of the possible genotypes for the offspring.
	unsigned int i,j,k,l,x;
	int gen1,gen2,type,go;
	vint genPar,a1,a2;

	for(k=0;k<uall.size();k++){	//this is counting the number of each allele among the children.
		for(i=0;i<kids.size();i++){
			j=kids[i];
			if(alls[j][k]==2){//make sure this is not already in there. We want distinct homozygotes.
				int ok=1;
				for(x=0;x<homKid.size();x++) if(homKid[x]==k) ok=0;
				if(ok==1) homKid.push_back(k);
			}
	}	}

	//Count observed genotypes
	//gen1=alls[kids[0]][0], gen2=alls[kids[0]][1];
	for(j=0;j<kids.size();j++){
		gen1=-1,gen2=-1;
		for(i=0;i<uall.size();i++){
			k=alls[kids[j]][i];
			if(alls[kids[j]][i]==1 && gen1==-1) gen1=i;
			if(alls[kids[j]][i]==1 && gen1!=-1) gen2=i;
			if(alls[kids[j]][i]==2) gen1=i, gen2=i;
		}
		go=1;
		for(i=0;i<a1.size();i++) if(a1[i]==gen1 && a2[i]==gen2) go=0;
		if(go==1) a1.push_back(gen1), a2.push_back(gen2);
	}
	//cout <<"a1 and a2\n";
	//for(i=0;i<a1.size();i++) cout <<a1[i] <<" " <<a2[i] <<endl;//a1.size() is now the number of observed (among the kids) genotypes.
	Nobs = (short) a1.size();

	if(folks.size()>0) for(i=0;i<uall.size();i++) if(alls[folks[0]][i]==uall[i]) genPar.push_back(uall[i]); //vector of parental alleles
	
	if(folks.size()==2){
		for(i=0;i<uall.size();i++){			
			for(j=0;j<uall.size();j++){ //matrix of possible genotypes, with the allele assigned across rows and columns,
				type=0;				//a 1 in any cell, indicates a genotype consisting of the corresponding row and col alleles.
				gen1=alls[folks[0]][i]*alls[folks[1]][j];
				gen2=alls[folks[1]][i]*alls[folks[0]][j];
				if(gen1+gen2>1) type=1; 
				else type=gen1+gen2;
				genotypes[i][j]=type;
	}	}	}	
	else {
		for(i=0;i<a1.size();i++)
			genotypes[a1[i]][a2[i]]=1, genotypes[a2[i]][a1[i]]=1; //These are the observed genotypes.
		if(folks.size()<2 && uall.size()==3 && homKid.size()==1 && a1.size()==2) return;
		if(kidsalls.size()>1){//If there is only one allele among the kids it has cond prob 1.
			if(folks.size()==1){//When one parent is known - possible genotypes are observed + any alleles 
				for(j=0;j<uall.size();j++){//not in parent with alleles of parent. 
					if(alls[folks[0]][j]==0){ //If j not in parent
						for(i=0;i<uall.size();i++){
							if(alls[folks[0]][i]==1){//pair with i in parent
								genotypes[i][j]=1;
								genotypes[j][i]=1;
			}	}	}	}	}			
			for(i=0;i<homKid.size();i++){//If a child is homozygous aa, 			
				for(j=0;j<uall.size();j++){//then a pairs with every other observed allele and
					if(j!=homKid[i] && uall[j]>=1) {//Why uall[j]>=1?
						genotypes[homKid[i]][j]=1;
						genotypes[j][homKid[i]]=1;
						int h=homKid[i];
					}
					for(k=0;k<uall.size();k++){//every other allele can pair with every other.
						if(j!=homKid[i] && k!=homKid[i] && j!=k) genotypes[j][k]=1;
			}	}	}		
			
			if(uall.size()==4 && folks.size()==0){//This next part just makes the matrix symmetric.
				for(i=0;i<4;i++){//kid1
					for(j=0;j<4;j++){//allele1
						if(genotypes[i][j]==1){
							for(k=j+1;k<4;k++){//allele2
								if(genotypes[i][k]==1){
									for(l=i+1;l<4;l++){	//kids2
										if(genotypes[l][j]==1 || genotypes[l][k]==1){
											genotypes[l][j]=1;
											genotypes[j][l]=1;
											genotypes[l][k]=1;
											genotypes[l][j]=1;
		}	}	}	}	}	}	}	}	}
	}
}

void params(int genotypes[][4],int &ngens,int possgens[][4],vint &gennum,int &homkids,int &homfolk,int **alls,
			int nall,vint kids,vint folks)
//This function calculates some of the quantities that I need to find the correct distribution.
{
	short x,j,k,l,m,famsize= (short) folks.size() + (short) kids.size();
	/*outfile <<"Possible genotypes: " <<endl;
		for(k=0;k<4;k++){
			for(j=0;j<4;j++) outfile << genotypes[k][j] <<" ";
			outfile <<endl;
		}*/
		
	ngens=0;
	for(x=0;x<4;x++){//Count the number of possible genotypes.
		for(j=0;j<4;j++){
			if(genotypes[x][j]==1) ngens++;
			if(genotypes[x][j]==1 && x==j) ngens++; //If hom., counts as two.
		}
	}
	ngens=ngens/2;
	
	k=0;
	while(k<ngens){
		for(x=0;x<4;x++){//Put possible genoytpes into new format.
			for(j=0;j<=x;j++){
				for(l=0;l<k;l++) if(genotypes[x][j]==1 && ((possgens[x][l]==1 && possgens[j][l]==1 && x!=j) || x==j)) continue;
				if(genotypes[x][j]==1 && x==j) possgens[x][k]=2,k++; //If hom., counts as two.
				else if(genotypes[x][j]==1) possgens[x][k]=1, possgens[j][k]=1,k++;
	}	}	}
	
		//outfile <<endl <<"Possgens:\n";
	/*for(x=0;x<4;x++){
		for(j=0;j<4;j++) outfile <<possgens[x][j] << " ";
		outfile <<endl;
	}
	outfile <<endl;*/

	for(l=0;l<famsize;l++){
		short ok=-1;
		for(unsigned int ll=0;ll<kids.size();ll++) if(l==kids[ll]) ok=ll;//Identify the index as a child.
		if(ok!=-1){
			x=kids[ok];
			for(m=0;m<ngens;m++){
				int yes=1;
				for(j=0;j<nall;j++) if(alls[x][j]!=possgens[j][m]) yes=0; 				
				if(yes==1) gennum.push_back(m);
			}
		}
		else gennum.push_back(-1);	//Parents whose genotypes are not in possgens will be assigned -1.	
	}


	/*outfile <<"Gennum: ";
	for(m=0;m<gennum.size();m++) outfile <<gennum[m] <<" ";*/
	homkids=0;
	for(x=0;x<4;x++){ //This is the number of possible homozygous genotypes, not the observed number.
		for(j=0;j<4;j++) if(possgens[x][j]==2) homkids++;
	}
	homfolk=0;
	for(unsigned int xx=0;xx<folks.size();xx++){//Count the number of homozygous parents.
		for(j=0;j<nall;j++){
			k=folks[xx];
			if(alls[k][j]==2) homfolk++;
		}
	}
}

double stat2(vint aff,int **alls,vint kids,int mod,double S,int nall,int all,vint &T,int possgen[][4],vint gennum,int ngens,
			vint folks,short Nobs,int homkids,int homfolk)//This function calculates S given X and T.
{
	unsigned int k;
	vint affnew;
	int i, unaff = 0;//What is unaff? Just the way unaffecteds are coded.
	int Sj=0,y=0,j,Si=0,go=0,count=0,A1=0,A2=0;
	vint a1,a2;
	for(int iaff = 0; iaff < (int) aff.size(); iaff++){
		if(aff[iaff]==0) affnew.push_back(unaff);
		else affnew.push_back(aff[iaff]);
	}
	
	for(k=0;k<kids.size();k++){ 
		j=kids[k];
		y=alls[j][all];
		if(mod==2) if(y!=0) y=1;
		if(mod==3){
			if(y==2) y=1;
			else y=0;
		}
		int a=affnew[j];
		Sj+=y*affnew[j];		
	}
	T.push_back(Sj);
	
	//Calculate the possible values of the statistic.
	if(ngens==2){
		if(homkids==1 && kids.size()>2 && homfolk!=1 && nall==2) go=0;//Not informative.
		else{//Two possible values of S, switch genotypes.	
			for(k=0;k<kids.size();k++){ 
				j=kids[k];
				if(gennum[j]==0) y=possgen[all][1]; //Gennum only has kids genotypes identified.
				else if(gennum[j]==1) y=possgen[all][0];
				if(mod==2) if(y!=0) y=1;
				if(mod==3){			
					if(y==2) y=1;
					else y=0;
				}
				//int aff=t[j];
				Si+=y*affnew[j];		
			}			
			T.push_back(Si);
		}
	}
	else if(homkids==2){	//This is possible hom kids not observed.	
		if(folks.size()==2 && kids.size()==2){
			for(i=0;i<3;i++){
				Si=0;
				for(k=0;k<kids.size();k++){
					j=kids[k];
					y=alls[j][all];
					if(i==0){ //I'm doing these explicitly for now.
						if(y==2 || y==0) y=1; 
						else if(y==1) y=0;
					}
					if(i==1){ //I'm doing these explicitly for now.
						if(y==2 || y==0) y=1; 
						else if(y==1) y=2;
					}
					if(i==2){ //I'm doing these explicitly for now.
						if(y==2) y=0; 
						else if(y==0) y=2;
					}
					if(mod==2) if(y!=0) y=1;
					if(mod==3){			
						if(y==2) y=1;
						else y=0;
					}
					Si+=y*affnew[j];
				}
				T.push_back(Si);
			}
		}
		else{
			for(k=0;k<kids.size();k++){ 
				j=kids[k];
				y=alls[j][all];
				if(y==2) y=0;
				else if(y==0) y=2; 
				if(mod==2) if(y!=0) y=1;
				if(mod==3){			
					if(y==2) y=1;
					else y=0;
				}
				Si+=y*affnew[j];		
			}		
			T.push_back(Si);
		}
	}

	//Check to see if the family is informative.
	if(T.size() < 2) go = 0;
	else{
		go=0,A1=T[0];
		A2=T[1];
		for(unsigned int ii=1;ii<T.size();ii++) if(T[ii]!=A1) go=1;
	}
	if(go==0){//Not informative.
		T.clear();
		Sj=0;//Don't augment test statistic.
	}	
	a1.clear();
	a2.clear();
	
	return(Sj);
}

short moreinf(vint aff,int **alls,vint &kids,int mod,double S,int nall,int all,vint &T,int possgen[][4],vint gennum,int ngens,
			 vint folks,short Nobs,int homkids,int homfolk,double& Save)//Everything that goes into Stat must be included.  
			 //aff, kids, gennum must all be updated here.
{
	vint pair1,pair2,kidsi;
	unsigned int i,j,go=0;
	Save=0;
	
	//outfile <<"aff: ";
		//for(j=0;j<aff.size();j++) outfile <<aff[j] <<" ";
	for(i=0;i<kids.size();i++){
		for(j=i+1;j<kids.size();j++){
			int ii=kids[i],jj=kids[j]; //I should be looking through kids only.
			if(gennum[ii]!=gennum[jj]){	
				kidsi.push_back(ii), kidsi.push_back(jj);//This will give the actual indices in the family.  check ii or i
				Save+=stat2(aff,alls,kidsi,mod,S,nall,all,T,possgen,gennum,ngens,folks,Nobs,homkids,homfolk);
				if(T.size()>1) pair1.push_back(ii),pair2.push_back(jj); //CHECK here too!!!
				kidsi.clear();
				T.clear();
			}			
		}		
	}
	if(pair1.size()>0)	Save=Save/double(pair1.size());
	else Save=0;
	kidsi.clear();
	if(pair1.size()>0){
		go=1;       
		//Randomly choose a pair, k, in pairs. It does matter which is chosen, because though all will affect the total prob. equally
		//the same is not true of the observed value of S.		
		int k=0;		
		double last=0,next;
		double unif = (double) rand()/RAND_MAX;
		for(i=0;i<pair1.size();i++){
			next=double(i+1)/double(pair1.size());
			if(last<=unif && unif<=next) k=i;
			last=double((i+1))/double(pair1.size());
		}
		int t1=pair1[k];
		int t2=pair2[k];
						
		kidsi.push_back(pair1[k]),kidsi.push_back(pair2[k]);
		kids.clear();
		for(i=0;i<kidsi.size();i++)kids.push_back(kidsi[i]);
		
		int y1=kidsi[0];
		int y2=kidsi[1];
		kidsi.clear();
		int x1=kids[0],x2=kids[1];
	}
	return(go);
}
void Node2::setNode2(double prob,REC2 *r)
{//Monte Carlo uses this same function, I've just not assigned spathj and lpathj.
	tp=prob;	
	rec=r;
}
void freerec2(Rec2 *rec)
{
	void freerec2(Rec2 *rec);
	if(rec->nextrec != NULL) freerec2(rec->nextrec);
	free(rec);
	return;
}
#define FREE_ARG char*

void free_NDvector2(Node2 *v, long nl,long nh)
{
	free((FREE_ARG) (v+nl-NR_END));
}
REC2 * crerec2(double r,double R[],double pr)	//This function creates a record and stores values in p and r
{		
	REC2 *record;

	record=(REC2 *)malloc(sizeof(REC2));	
	record->pastr=r;
	for(int i=0;i<NumAll;i++)
		record->pastR[i]=R[i];		
	record->pastp=pr;
	record->nextrec=NULL;	
	return(record);
}

Node2 *NDvector2(long nl, long nh)
/* allocate an NODE vector with subscript range v[nl..nh] */
{
	Node2 *v;

	v=(Node2 *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(Node2)));
	//if (!v) nrerror("allocation failure in NDvector()");
	return v-nl+NR_END;
}

void dist(Node2 *nodes,vint T,double Sall[][4],int mode,int totA) 
{		
	int numrec,l; //# of records
	unsigned int i;
	double npr,p,r=0,R[NumAll];
	vint diff,rj,lowlim,uplim,x;		
	REC2 *newrec,*currec,*nxt,*curr; //create pointers for traversing the network.
	for(i=0;i<NumAll;i++) R[i]=0;
	numrec=1;
	currec=nodes[1].rec;

	while (currec != NULL) 
	{
		for(i=0;i<T.size();i++){														
			r=currec->pastr+T[i];	//calculate rank length
			for(l=0;l<totA;l++) R[l]=currec->pastR[l]+Sall[l][i];
			p=0.0;						
			if (currec->pastp<0.0000001) npr=p;	//calculate prob length isn't this redundant?
			else npr=currec->pastp+p;							
			newrec=crerec2(r,R,npr);
			numrec++;
			if (nodes[2].rec == NULL)		//If the next record is null, make it the new one
				nodes[2].rec=newrec;
			else if(mode==1){
				if (nodes[2].rec->pastr > newrec->pastr){ //Else if the new r is less than the old one
					newrec->nextrec = nodes[i+1].rec;		//the new record points to the old
					nodes[2].rec = newrec;
				}
				else{ 
					curr=nodes[2].rec;		//otherwise, 
					nxt=curr->nextrec;
					while (nxt != NULL){			//move through until pointing to null
						if (r == curr->pastr || (nxt != NULL && (r < nxt->pastr)))
								break;
						curr=nxt;
						nxt=curr->nextrec;
					}
					if (r == curr->pastr){ //if the record is already there, augment the prob and remove rec
						curr->pastp=addlog(curr->pastp,newrec->pastp);
						free(newrec);
						numrec--;
					}
					else {
						newrec->nextrec=nxt;	//otherwise, add the record
						curr->nextrec=newrec;
					}
				}
			}
			else if(mode==2){
				curr=nodes[2].rec;		//otherwise, 
				nxt=curr->nextrec;								
				int eq=0;
				while (nxt != NULL){			//move through until pointing to null
					eq=1;//Check to see if r and curr->pastr are the same.
					for(l=0;l<totA;l++) if(R[l]!=curr->pastR[l]) eq=0;
					if (eq==1)
							break;
					curr=nxt;
					nxt=curr->nextrec;
				}
				eq=1;//Check to see if R and curr->pastR are the same.
				for(l=0;l<totA;l++) if(R[l]!=curr->pastR[l]) eq=0;
				if (eq==1){//if the record is already there, augment the prob and remove rec
					curr->pastp=addlog(curr->pastp,newrec->pastp);
					free(newrec);
					//newrec==NULL;
					//freerecM(newrec);
					numrec--;
				}
				else {
					newrec->nextrec=nxt;	//otherwise, add the record
					curr->nextrec=newrec;
				}
			}//else if
		}
			currec=currec->nextrec;			
	}
}
void moment2(REC2 *tRec,double prob,double &exval,double &var)
{
	REC2 *currec;
	double unp=0;	
	
	currec=tRec;
	while(currec!=NULL){
		exval+= (currec->pastr)*(exp(currec->pastp)/exp(prob));
		var+=pow((currec->pastr),2)*(exp(currec->pastp)/exp(prob));
		currec=currec->nextrec;
	}	
	return;
}

double pvalue2(double exval,double var,double prob,REC2 *tRec,double ObsS)
{
	REC2 *currec = tRec;
	double unp=0, unp1 = 0, p;	
	int first = 1;
	//int yes = 1;

	double normS = pow(ObsS - exval, 2) / var;

	while(currec!=NULL)
	{
		double normT = pow(currec->pastr - exval, 2) / var;
		if(normT >= normS - 0.0000000001)
		{//Do this to avoid adding an extra 1 to the unnormalized probability.
			if(first == 1)
			{
				first = 0;
				unp = currec->pastp;
			}
			else unp = addlog(unp, currec->pastp);

			/*if(abs(currec->pastr-exval)>=abs(ObsS-exval)) {
				if(yes==1) unp=currec->pastp, yes++;
				else unp=addlog(unp,currec->pastp);
			}*/
		}
		currec=currec->nextrec;
	}
	p = exp(unp - prob);	
	if(p > 1) p = 1;
	return(p);
}
